#include "modeldef.h"
#include <string.h>
#include "owbasic.h"
#include "comp.h"
#include "cstack.h"
#include "file.h"
#include "shared.h"
#include "form.h"
#include "ostring.h"
#include "graphic.h"
#include "rc.h"


uchar *prog;          /* the program pointer for compile*/
uchar *aprog;         /* pointer for debug output lex() */
uchar *prog_start;    /* start of the program */

uchar token_type;
uchar datatype;
int tok;

/* variables for overlay managment */
bool a_overlay;
PC a_overlaystart;
PC a_overlayend;

uchar *token_start;
uchar *token_end;
jmp_buf errorret;

struct proc FAR proc_table[NUM_PROC];
int last_proc;
int num_proc = NUM_PROC;

/*--- include-stack ---*/
SourcePtr IncStack[INCSTACKSIZE];
SourcePtr *IncStackPtr;

PC nullpc={NULL};

int ctos;               /* index to top of control stack */
uchar FAR default_datatype;
int compile_procedure(void);

void set_version(void);

int current_version = OWBVersion;
int desired_version = OWBVersion;

bool is_fptrcall = FALSE;

struct proc FAR *cpp; /* pointer to current procedure definition */

int varlistaddr; /* symbol table at start of procedure */

#ifndef SMALL_NO_CACHE
/* cacheing function prototypes */
#define CACHE_VERSION 0x004
#define CACHE_BUFSIZE (1024 * 3)
#define CACHE_MAXSIZE (CACHE_BUFSIZE - sizeof (int) - 50)

/*typedef int (*c_sffunc_t) (const uchar*,int,byte FAR*);

int   cache_lookup (void);
int   cache_nextfile (c_sffunc_t sffunc, int size);*/ /* load or save next cache file */

void  cache_init (void);
void  cache_getname (void);

/*int   cache_find (FILE_INFO *fi);*/
int   cache_load (void);
int   cache_save (void);

bool  cache_read (void);
void  cache_write (void);

int   cache_geti (void);
void  cache_puti (int i);

int   c_cnr;
/*int   c_cnt;*/
bool  c_ctbl_exists;
bool  c_ctbl_looked_up = FALSE;
int   c_ctbl_cnt;
char* c_csig = NULL;

const char FAR c_ctblname[] = "OWBasic,cachetable";
const char FAR c_filename[] = "OWBasic,cache%02.2i,%s";
#endif

uchar DT(uchar dtyp)
{
  /*
     apply default type of identifiers
     if type is unknown (not given)
  */
  if ((dtyp & TYPEMASK) != DUNKNOWN)
    return (dtyp);
  return ((dtyp & ~TYPEMASK) | default_datatype);
}

#ifndef SMALL_NO_BREAK
static uchar FAR cstack_fl[] = "bc";
static csstype FAR cstack_ff[] = {C_BRK, C_CNT};
void compile_break (int jmp, int n) /* break and continue in control structure (MB,4.40) */
{
  char nls[IDENTLEN] = {'~'};
  unsigned int loc;
  int ref;

  nls[1] = cstack_fl[n];
  ref = cstack[ctos - 1].brkuse & C_NMASK;
  cstack[ref].brkuse |= cstack_ff[n];
  sprintf (nls + 2, "%d", cstack[ref].brkcnt);

  loc = find_label ((uchar*) nls);
  ref = newentry (DREFERENCE, (uchar*) "");
  xdata[ref] = loc;
  xdata[ref + 1] = (int) pc.p;
  ADDJMP (jmp, 0);
}

void cstack_nextlabel (cstack_entry FAR* cs, int n)
{
  char nls[IDENTLEN] = {'~'};

  sprintf (nls + 2, "%d", cs->brkcnt);
  if (cs->brkuse & cstack_ff[n])
  {
    nls[1] = cstack_fl[n];
    xdata[find_label ((uchar*) nls)] = (int) pc.c; /* position of label */
  }
}
#else
#define cstack_nextlabel(cs,n)
#endif

#ifndef SMALL_NO_DIRECTIVE
static signed char d_cnt = 1;
static signed char d_pos = 1;
#endif

int compile_command()
{
  int i;
  PC cpc;
  uchar dtype = DUNKNOWN;
  int rc = RC_CONTINUE;
  /*bool dneg = FALSE;*/
  uchar name[IDENTLEN];

  if (*prog == 0)
    return (RC_EXIT);

#ifndef SMALL_NO_DIRECTIVE
  if (/*(*prog == '.') ||*/ (*prog == '#')) /* compile directive (MB,4.40) */
  {
    ++prog;
    lex ();
    tok = look_up (commandtable);
    if (tok == ENDIF)
    {
      if (d_cnt < 0)
      {
        if ((d_cnt < 0) && (d_cnt == d_pos))
        {
          ++d_cnt;
          d_cnt = -d_cnt;
        }
        else
          ++d_cnt;
      }
      else
        --d_cnt;
      return (RC_CONTINUE);
    }
    if (tok != IF)
    { /* constant assignment */
      dtype = DCONSTANT;
      i = findentry_token (&dtype);
      expect ('=');
      expect_inumber ();
      xdata[i] = lexint;
      return (RC_CONTINUE);
    }
    if (d_cnt < 0)
    {
      --d_cnt;
      prognl ();
      return (RC_CONTINUE);
    }
    ++d_cnt;

    cpc = pc;
    if (!comp_exp (DBOOLEAN))
      serror (79);
    pc = cpc;
    if (getint (pc) == 0)
      d_pos = d_cnt = -d_cnt;

  /*get_directive:
    lex ();

    tokcpy_ident (name);

    if (strcmp_nf ((uchar*) name, (uchar FAR*) FN_NOT) == 0)
    {
      dneg = !dneg;
      goto get_directive;
    }
    if (tok == NUMBER)
    {
      putback ();
      cpc = pc;
      if (!comp_exp (DBOOLEAN))
        serror (79);
      if (BOOL_XOR (dneg, !getint (pc = cpc)))
        d_pos = d_cnt = -d_cnt;
      return (RC_CONTINUE);
    }

    switch (look_up (directivetable))
    {
    case D_VARDEF:
      lex ();
      if (BOOL_XOR (dneg, searchentry_token (&dtype) == -1))
        d_pos = d_cnt = -d_cnt;
      break;
    case D_PROCFUNCDEF:
      lex ();
      tokcpy_ident (name);
      if (BOOL_XOR (dneg, search_procfunc (name, 0, FALSE) == -1))
        d_pos = d_cnt = -d_cnt;
      break;
    default:
      serror (0);
    }*/
    return (RC_CONTINUE);
  }

  if (d_cnt < 0)
  {
    prognl ();
    return (RC_CONTINUE);
  }
#endif
  lex ();
  if (token_type == 0)
    serror (0);
  switch (token_type)
  {
  case TNUMBER:
    /* numbers as labels */
    if (datatype!=DINTEGER) serror(0);
  case TLABEL:
    /* labels starting with '$' */
    i=find_token_label();
    if (xdata[i]!=0) serror(6); /* label exists */
    xdata[i]=(int)pc.c;         /* position of label */
    break;
  case TKEY:
    switch (tok)
      {
      case CLIPBOARD:
      case FILEBUFFER: compile_assignment(); break;
      case WHILE: compile_while(); break;
      case ELSE: compile_else(); break;
      case REM: /* nothing to do */; break;
      case PRINT: compile_print(); break;
      default: serror(0);
      }
    break;
  case TIDENT:
    if ((*prog == '=') || (*prog == '[') || (*prog == '{'))
      compile_assignment ();
    else
    { /* commands and procedures */
      tok = look_up (commandtable);
      switch (tok)
      {
#ifndef SMALL_NO_BREAK
      case BREAK:
      case CONTINUE: compile_break (JMP, tok - BREAK); break;
#endif
      case GOTO: compile_goto(JMP); break;

      case PROC: compile_procfunc(FALSE); break;
      case FUNC: compile_procfunc(TRUE); break;
      case ENDP: compile_endp(FALSE); break;
      case GOSUB: compile_gosub(); break;
      case FRETURN:
        if (cpp != NULL)
          comp_exp (cpp->rtype);
        ADDCODE (B_RETURN);
        break;
      case RETURN:
        if (cpp == NULL)
        {
          ADDCODE (B_RETURN);
        }
        else
          compile_endp (TRUE);
        break;
      case REM: break;

        /* if .. then .. else .. endif */
      case IF: compile_if (); break;
      case ENDIF: compile_endif (); break;
        /* for .. to .. next */
      case FOR: compile_for (); break;
      case NEXT: compile_next (); break;
        /* case .. of .. endcase */
        /* case SELECT: compile_case (); break;*/
      case CASE: compile_case (); break;
      case ENDCASE: compile_endcase (); break;
        /* text io */
      case PRINT: compile_print (); break;
      case INPUT: compile_input (); break;

        /* while .. endwhile */
        /* case WHILE: compile_while (); break; ! WHILE is TKEY */
      case WEND: compile_endwhile (); break;

        /* DO .. LOOP */
      case DO: compile_do (); break;
      case LOOP: compile_loop (); break;

      case WAIT: compile_wait ();break;
      case DIM: compile_dim (); break;
      case CONST: compile_const (); break;
      case INCLUDE: if (compile_include (FALSE)) rc = RC_INCLUDE; break;
      case APPEND: compile_include (TRUE); rc = RC_APPEND; break;
      case OVERLAY: compile_overlay (); break;
      case LOCAL: compile_local (); break;
      case CALL: is_fptrcall = TRUE;
      case UNKNOWN:
        if (!compile_userprocedure (NULL))
          if (!compile_procedure ())
            serrortoken (2040); /* Unknown Procedure */
        break;
      case VERSION: set_version (); break;
      case DEFAULT: lex ();
        if (datatype == DUNKNOWN)
        {
          tokcpy_ident (name);
          if (strcmp_nf (name, FN_INT) == 0) default_datatype = DINTEGER;
          if (strcmp_nf (name, FN_FLOAT) == 0) default_datatype = DFLOAT;
          if (strcmp_nf (name, FN_STRING) == 0) default_datatype = DSTRING;
        }
        else
          default_datatype = datatype;
        break;
      default:
        serrortoken (2020);
      }
    }
    break;
  case TDELIM: /* OK */ break;
  default: serror (0);
  }
  return (rc);
}

/* ---------------------- compiler ----------------------*/
void compile_assignment (void)
{
  uchar dtype;
  int use_addr = lex_ref;
  bool is_fb;
  uchar schar = FALSE;
  /* Compile variable */
  dtype = datatype; /* save datatype */
  is_fb = tok == FILEBUFFER;
  if (is_fb || tok == CLIPBOARD)
  {
    /* special case filebuffer */
    expect('['); comp_exp(DINTEGER); expect(']');
    expect('=');
    comp_exp(DINTEGER);
    ADDCODE (is_fb ? B_FBPUT : B_CBPUT);
    return;
  }
  if (tok == PROP_FBBSIZE)
  {
    expect ('=');
    comp_exp (DINTEGER);
    ADDCODE (B_SETFBBSIZE);
    return;
  }

  if (use_addr == 4)
    serror (0);
  if (use_addr == 0)
    comp_var (&dtype, &use_addr);
  else
  {
    comp_varaddr (&dtype);
    if (use_addr == 2)
    {
      ADDCODE (B_GETVARI);
      comp_varindex (&dtype);
    }
  }

  if ((dtype == DSTRING) && (!use_addr))
  {
    if (*prog=='{')
    {
      /* destination is char of string */
      lex ();
      comp_exp (DINTEGER);
      expect ('}');
      dtype = DCHAR;
      schar = TRUE;
    }
  }

  /* get the = */
  expect ('=');

  /* get the value */
  comp_exp (dtype & TYPEMASK);

  /* assign the value to the variable */
  switch (dtype & TYPEMASK)
  {
  case DFPTR:
  case DBOOLEAN:
  case DINTEGER:
    ADDCODE(B_ASSIGN_I);
    break;
  case DFLOAT:
    ADDCODE(B_ASSIGN_F);
    break;
  case DSTRING:
    ADDCODE(B_ASSIGN_S);
    break;
  case DCHAR:
    ADDCODE (schar ? B_ASSIGN_SC : B_ASSIGN_I);
    break;
  }
}

void compile_wait (void)
{
  comp_exp (DINTEGER);
  ADDCODE (B_WAIT);
  ADDCODE (B_WAIT2);
}

void compile_print(void)
{
  byte newline = TRUE;
  uchar atyp;
  lex ();
  while (token_type != TDELIM) 	/* get next list item */
    {
      if (token_type == TEDELIM)  /* ';' or ',' */
        {
          if (tok == ',')
            ADDCODE (B_PRINT_TAB);
          newline = FALSE;
        }
      else                      /* expression */
        {
          putback ();
          comp_exput (&atyp);
          switch (atyp & TYPEMASK)
            {
            case DINTEGER: ADDCODE (B_PRINT_INT); break;
            case DFLOAT:
              ADDCODE (B_CONV_FS);
              ADDCODE (B_PRINT_STRING);
              break;
            case DSTRING: ADDCODE (B_PRINT_STRING); break;
            case DCHAR: ADDCODE (B_PRINT_CHAR); break;
            case DBOOLEAN: ADDCODE (B_PRINT_BOOLEAN); break;
            default: serror (22);
            }
          newline = TRUE;
        }
      lex ();
    }
  if (newline) ADDCODE (B_PRINT_NL);
  ADDCODE (B_PRINT_END);
}

bool compile_include (bool append)
{
  int i;
  uchar h[NAMELEN + 2];
  lex ();
  if ((token_type != TIDENT) && (token_type != TSTRING))
    serror(41);
  if (append)
    return (TRUE);
  /* check if already included */
  h[0] = '#';
  if (token_type == TIDENT)
    tokncpy (&h[1], NAMELEN);
  else
    sconstncpy (&h[1], NAMELEN);
  i = find_label (h);
  if (xdata[i] != 0)
    return (FALSE);
  xdata[i] = 1;
  return (TRUE);
}

void compile_overlay (void)
{
  if (cpp != NULL)
    serror (0); /* no OVERLAY in proc declaration */

  expect_inumber ();
  if (lexint == 1)  /* 0 - OFF, 1 - ON */
  {
    overlays_used = TRUE;
    /* start (new) overlaysegment */
    a_overlay = TRUE;
    a_overlayend = a_overlaystart = pc; /* segment length is zero */
  }
  else /* the following procedures are not overlayed */
    a_overlay = FALSE;
}

/*-------------------------------------------------------*/
void compile_procfunc (bool func)
{
  int paravar[MAXPARAM]; /* variables for parameters */
  int procnr; /* reference to procedure data */
  int htok;
  uchar dtyp;
  int var;
  int paracount;
  uchar pname[IDENTLEN];
  byte old_dr = declaration_required;


  declaration_required = 0;

  if (cpp) /* does already a procedure definition run? */
    serror (48);

  if (pc.c!=bin_start.c) /* is there code outside proc. before this definition ?*/
    serror (50);

  lex ();        /* get name of procedure */

  if (func)
    dtyp = DT (datatype);
  else
    dtyp = DUNKNOWN;

  if (token_type != TIDENT)
    serror (41);

  tokcpy_ident (pname);

  if (search_procfunc (pname, dtyp) >= 0)
    serror (52); /* proc/func already exists */

  varlistaddr = listnext;     /* begin of local variables in symbol table */
  procnr = new_procfunc(pname,pc,dtyp);/* register new proc */
  cpp = &(proc_table[procnr]);  /* procedure which is currently defined */

  if (a_overlay) /* are we in overlay mode ? */
  {
    pc=a_overlaystart; /* start compiling again at overlay startposition */
    cpp->addr=pc;
    ADDVAL(procnr);    /* store procedure number as first value to
                          identify the loaded segment */
  }

  htok=lex(); dtyp=datatype;/* get first parameter */
  paracount=0;

  while ((htok != DELIMITER) && (htok != END))
    {
      if (htok == VAR)  /* VAR found */
      {
        htok = lex (); /* next word is parameter name */
        dtyp = datatype | KREFERENCE;
      }

      if (token_type != TIDENT) serror(41);  /* name of parameter */
      if (paracount == MAXPARAM) serror(46); /* too much parameters */

      if (*prog=='[') /* parameter is array */
        {
          dtyp |= KARRAY;
          if (!(dtyp & KREFERENCE)) serror(64);
        }

      var = searchentry_token(&dtyp); /* exist global variable ? */
      if (var>=0) serrortoken(2076);  /* Yes: Error */

      var = findentry_token(&dtyp);

      cpp->paratype[paracount]=dtyp; /* register type of par. */
      paravar[paracount]=var; /* pointer to parameter */
      if (*prog=='[')
      {
        lex(); /* get '[' */
        expect(']');
      }
      htok=lex(); dtyp=datatype;
      paracount++;
      if (htok==',')
      {
        htok=lex(); dtyp=datatype;
      }
    }

  cpp->paratype[paracount]=DUNKNOWN; /* mark end of para. list */

  /* add code to get parameters from stack */
  while (paracount>0)
  {
    paracount--;
    dtyp=cpp->paratype[paracount];
    if (dtyp & KREFERENCE) /* call by reference ? */
    {
      /* get address */
      ADDCODE(B_POPI);
    }
    else
    {
      /* get value */
      dtyp=dtyp & TYPEMASK;
      switch(dtyp)
      {
      case DFPTR:
      case DBOOLEAN:
      case DCHAR:
      case DINTEGER: ADDCODE(B_POPI); break;
      case DFLOAT: ADDCODE(B_POPIF); break;
      case DSTRING: ADDCODE(B_POPIS); break;
      default: serror(22);
      }
    }
    ADDVAL(xdata[paravar[paracount]]);
  }

  declaration_required = old_dr;
}

void compile_endp(bool func)
{
  /* endp for procedures OR return for functions */
  if (cpp==NULL)
    serror (49); /* only valid in procedure definitions */
  if (func)
  {
    if ((*prog == 0x0A) || (*prog == 0x0D) || (*prog == 0))
    {
      ADDCODE (B_RETURN);
      return;
    }
    comp_exp (cpp->rtype); /*compile expression (value on stack)*/
  }
  if (ctos != 0)
    notclosederror (cstack[ctos - 1].type); /* unclosed control in procedure */
  ADDCODE (B_RETURN);       /* add code for return */
  listhide (varlistaddr);   /* hide local variables in symbol list */
  if (a_overlay) /* is procedure compiled in overlaymode ?*/
  {
    cpp->len = pc.b - a_overlaystart.b; /* length of procedure */
    if (pc.b > a_overlayend.b)
      a_overlayend = pc; /* correct overlay segment end if neccessary */
    pc = a_overlayend; /* set pc to overlay segment end, in case normal code
                          follows */
    /* save overlay code to flash ram*/
    if (!SaveOverlay (a_overlaystart.c, cpp->len, cpp - proc_table))
      serror (68);
  }
  bin_start = pc;            /* main starts after procedures */
  cpp = NULL;                /* not in procedure definition */
}


void compile_drop (uchar ltype)
{
  switch (ltype & TYPEMASK)
  {
  case DBOOLEAN:
  case DCHAR:
  case DFPTR:
  case DINTEGER:
    ADDCODE (B_DROP);
    break;
  case DFLOAT:
    ADDCODE (B_DROPF);
    break;
  case DSTRING:
    ADDCODE (B_DROPS);
    break;
  }
}

bool compile_userprocedure (uchar *ltype)
{
  /* call for user procedure (ltype==NULL) OR function (ltype!=NULL) */
  int procnr;
  uchar version;
  uchar hdtyp, rtype;
  uchar pname[IDENTLEN];
  struct proc FAR *pp;
  uchar ltype2 = DFPTR;
  uchar* rpos;
  uchar* vpos;
  PC pcp;
  int use_addr;
  uchar pltype = DUNKNOWN;

  bool is_call = is_fptrcall;

  is_fptrcall = FALSE;

  if ((datatype != DUNKNOWN) && (ltype == NULL)) /* function called as procedure (MB,4.25) */
  {
    pltype = datatype;
    ltype = &pltype;
  }
  if (is_call)
  {
    rtype = datatype;
    if (pltype != DUNKNOWN)
      expect ('(');
    vpos = prog;
    lex ();
    tokcpy_ident (pname);
    pcp = pc;
    comp_var (&ltype2, &use_addr);
    pc = pcp;
    ltype2 = DFPTR;
    datatype = rtype;
  }
  else
    tokcpy_ident (pname);

  if (ltype == NULL)
    hdtyp = DUNKNOWN;
  else
    *ltype = hdtyp = DT (datatype);

  procnr = search_procfunc (pname, hdtyp);  /* find user procedure */
  if (procnr < 0)
  {
    if (pltype != DUNKNOWN)
    {
      if (!compile_function (ltype))
        return (FALSE);
      compile_drop (pltype);
      return (TRUE);
    }
    else
      return (FALSE);
  }
  pp = &(proc_table[procnr]);
  /* compile parameters */
  if (ltype == NULL)
  {
    comp_para (pp->paratype, &version, DELIMITER);
  }
  else
  {
    if (!is_call)
      expect ('(');
    comp_para (pp->paratype, &version, ')');
  }

  if (pp->len > 0) /* is procedure overlayed ?*/
  {
    if (cpp) /* if within procedure definition
                we have to check, that no procedure of the same
                overlay segment is called */
    {
      if (cpp->addr.b == pp->addr.b)
      {
        /* procedure in same overlay can't be called */
        serror (70);
        return (FALSE);
      }
    }
    ADDCODE (B_CALL_OVERLAY); /* call of an overlayed procedure */
    addcodei (procnr); /* the number of the procedure */
    ADDCODEP (pp->addr); /* the address where to put it */
  }
  else
  {
    if (pp->len < 0) /* is fptr */
    {
      if (!is_call)
        return (FALSE); /* cannot be called as normal procedures */
      rpos = prog;
      prog = vpos;
      lex ();
      comp_var (&ltype2, &use_addr);
      if (apc.c)
      {
        *apc.c = B_GETVAR; /* overwrite B_IMM */
        apc.c = NULL;
      }
      else
      {
        ADDCODE(B_GETVARI);
      }
      prog = rpos;
      ADDCODE (B_CALL_FPTR);
    }
    else /* normal procedure */
    {
      ADDCODE (B_CALL);
      ADDCODEP (pp->addr); /* code for call */
    }
  }

  if (pltype != DUNKNOWN)
    compile_drop (pltype);
  return (TRUE);
}

/*----------------------------------------------------------------*/
int find_token_label()
{
  uchar htoken[IDENTLEN];
  if (*token_start=='$') token_start++;
  tokcpy_ident(htoken);
  return find_label(htoken);
}

int find_label(uchar *s)
{
  int t;
  uchar ht=DLABEL;
  t=findentry_name(&ht,s);
  return t;
}

/*-----------------------------------------------------------------*/
int search_procfunc(uchar *s, uchar dtyp)
{
  int t;

  for (t = 0; t < NUM_PROC; ++t)
    if ((far_strncmp ((char FAR*) proc_table[t].name, (char FAR*) s, IDENTLEN - 1) == 0)
     && (proc_table[t].rtype == dtyp))
      return (t);
  return (-1);
}

int new_procfunc(uchar *s,PC addr,uchar typ)
{
  last_proc++;
  if (last_proc>=num_proc) serror(51);
  far_strncpy((char FAR*)proc_table[last_proc].name,(char *)s,IDENTLEN-1);
  proc_table[last_proc].addr=addr;
  proc_table[last_proc].rtype=typ;
  return last_proc;
}
/*----------------------------------------------------------------*/
void compile_goto(int jmp)
{
  unsigned int loc;
  int ref;
  expect_label();
  loc = find_token_label();
  if (xdata[loc]==0) /* label not (yet) defined */
    {
      ref = newentry(DREFERENCE,(uchar*)""); /* has to be linked later */
      xdata[ref]=loc;
      xdata[ref+1]=(int)pc.p;
      ADDJMP(jmp,0);
    }
  else
    {
      ADDJMP(jmp,xdata[loc]); /* create jump */
    }
}

void compile_gosub()
{
  int loc, ref;
  PC addr;

  expect_label();

  ADDCODE(B_CALL); /* create subroutine call */
  loc = find_token_label(); /* find destination */
  if (xdata[loc]==0) /* not (yet) defined */
    {
      ref = newentry(DREFERENCE,(uchar*)""); /* has to be linked later */
      xdata[ref]=loc;
      xdata[ref+1]=(int)pc.c;
      ADDCODEP(nullpc); /* dummy destination */
    }
  else
    {
      addr.c=(codet*)xdata[loc];
      ADDCODEP(addr); /* call address */
    }
}

/*----------------------------------------------------*/

void compile_local (void)
{
  /*uchar dtype = datatype;*/
  byte old_dr = declaration_required;

  lex ();
  if ((tok == NUMBER) && (datatype == DINTEGER))
  {
    declaration_required = lexint;
    return;
  }
  putback ();

  declaration_required = 0;

  while (lex () == IDENT)
  {
    if (lex_ref)
      datatype |= KREFERENCE;
    findentry_token (&datatype);
    if (*prog == ',')
      lex ();
  }

  declaration_required = old_dr;
}

static uchar NEAR suffix_type (char c)
{
  if (*prog == (uchar) '$')
    return (DSTRING);
  if (*prog == intchar)
    return (DINTEGER);
  if (*prog == floatchar)
    return (DFLOAT);
  if (*prog == (uchar) '!')
    return (DBOOLEAN);
  if (*prog == (uchar) '&')
    return (DCHAR);
  if (*prog == (uchar) '~')
    return (DFPTR);
  return (DUNKNOWN);
}


void compile_dim (void)
{
  char buf[IDENTLEN];
  struct proc FAR* cps;
  byte old_dr = declaration_required;
  uchar dtype, ctype;
  int vaddr;
  int i, l;
  long int size;
  int rowsize = 1;
  bool is_var = FALSE;

  declaration_required = 0;

  if (*prog == '&')
  {
    is_var = TRUE;
    ++prog;
  }
  while (lex () == IDENT)
  {
    dtype = datatype;
    if (is_var)
      dtype |= KREFERENCE;
    vaddr = findentry_token (&dtype);
    if ((dtype & TYPEMASK) == DFPTR) /* function pointer definition (MB,4.25) */
    {
      if (last_proc >= --num_proc)
        serror (51);
      cps = &proc_table[num_proc];
      tokcpy_ident ((uchar*) buf);
      l = strlen (buf);
      for (i = 0; i <= l; ++i)
        cps->name[i] = buf[i]; /* copy name to procdef */
      expect ('(');
      lex (); /* PROC or FUNC@ */
      cps->len = -1; /* fptr declaration */
      /*cps->rtype = datatype;*/
      switch (look_up (commandtable))
      {
      case PROC:
        cps->rtype = DUNKNOWN;
        break;
      case FUNC:
        cps->rtype = DT (datatype);
        break;
      default:
        serror (0);
      }
      i = 0;
      cps->paratype[0] = DUNKNOWN;

      if (*prog != ')')
        --i;
      while (*prog != ')')
      {
        if (lex () == VAR)
          ctype = KREFERENCE;
        else
        {
          ctype = DUNKNOWN;
          putback ();
          skipws ();
        }

        ctype |= suffix_type (*prog);

        if (*(++prog) == '[')
        {
          ++prog;
          ctype |= KARRAY;
          expect (']');
        }

        cps->paratype[++i] = ctype;
        skipws ();
        if (*prog == ',')
          lex ();
      }
      cps->paratype[i] |= KLAST;
      expect (')');


      /*if (*prog == ')')
        ++i;
      else
        do
        {
          if (lex () == VAR)
            ctype = KREFERENCE;
          else
          {
            ctype = DUNKNOWN;
            putback ();
            skipws ();
          }
          ctype |= suffix_type (*(prog));
          if (*(++prog) == '[')
          {
            ++prog;
            ctype |= KARRAY;
            expect (']');
          }

          cps->paratype[i] = ctype;

          skipws ();
          ++i;
          if (*prog == ',')
            lex ();
        } while (*prog != ')');
      cps->paratype[i - 1] |= KLAST;
      expect (')');*/
    }
    expect ('[');
    expect_inumber ();
    if (lexint < 0)
      serror (33);
    size = lexint + 1;
    if (*prog == ',') /* two dimensional array */
    {
      lex (); /* skip ',' */
      expect_inumber ();
      rowsize = lexint + 1;
      size *= rowsize;
    }
    else
      rowsize = 1;
    if (((dtype & KREFERENCE) != 0) && !is_var)  /* special case: procedure parameter
                                                    old style: array parameters are declared
                                                    with DIM within procedure */
    {
      xdata[vaddr + 1] = size;
      xdata[vaddr - 1] |= (KARRAY << 8);
    }
    /* normal case */
    else
    {
#ifdef LSI_C
      if (size > 0x7FFF)
        serror (33);
#endif
      expandentry (vaddr,size,rowsize);
    }
    expect (']');
    if (*prog == ',')
      lex ();
    if (*prog == '&')
    {
      is_var = TRUE;
      ++prog;
    }
    else
      is_var = FALSE;
  }

  declaration_required = old_dr;
}

void read_list (uchar *name,uchar dtype)
{
  int count = 0;
  int vaddr;
  /*bool sign = FALSE;*/
  int i;
  PC lpc;
  int FAR *ic;
  FLOATT FAR *fc;
  int hi;
  FLOATT hf;

  if (dtype == DCHAR) /* char array initialized with string (MB,4.10) */
  {
    if (*prog != '"')
    {
      if (*prog == '\'')
        iconst (lex ());
      else
        serror (22);
    }
    else
    {
      while (*++prog != '"')
      {
        if (*prog == '\\')
          ++prog;
        ++count;
        iconst (*prog);
      }
      ++prog;
    }
    expect (')');
  }
  else
  {
    lex ();
    while (tok != ')')
    {
      /*if (sign = (tok == '-'))
        lex ();*/

      switch (dtype)
      {
      case DSTRING: /* initialized string arrays (MB,4.25) */
        if (token_type != TSTRING)
          serror (0);
        comp_str ();
        i2push (firstconst - 2);
        break;
      case DBOOLEAN: /* boolean initialized arrays (MB,4.10) */
        if (tok == True)
          iconst (1);
        else if (tok == False)
          iconst (0);
        else if (datatype == DINTEGER && ((lexint == 0) || (lexint == 1)))
          iconst (lexint);
        else
          serror (22);
        break;
      case DINTEGER:
        putback ();
        expect_inumber ();
        iconst (lexint);
        /*if (datatype != DINTEGER)
          serror (22);
        iconst (/*sign ? -lexint : lexint);*/
        break;
      case DFLOAT:
        putback ();
        lpc = pc;
        if (!comp_exp (DFLOAT))
          serror (79);
        pc = lpc;
        fconst (getfloat (pc));
        /*if ((datatype != DINTEGER) && (datatype != DFLOAT))
          serror (22);
        fconst (sign ? -lexfloat : lexfloat);*/
        break;
      }
      ++count;
      if (*prog == ',')
        lex ();
      if ((*prog == 0x0A) || (*prog == 0x0D))
        lex ();
      lex ();
    }
  }
  /* not nice, but works :
     invert order of constants
  */

  switch (dtype)
    {
    case DSTRING:
      for (i = 0; i < count; ++i)
        iconst (i2pop ());
      break;
    case DCHAR:
    case DBOOLEAN:
    case DINTEGER:
      ic = &xdata[firstconst];
      for (i = 0; i < count / 2; ++i)
      {
        hi = ic[i];
        ic[i] = ic[count - 1 - i];
        ic[count - 1 - i] = hi;
      }
      break;
    case DFLOAT:
      fc = (FLOATT FAR*) (&xdata[firstconst]);
      for (i = 0; i < count / 2; ++i)
      {
        hf = fc[i];
        fc[i] = fc[count - 1 - i];
        fc[count - 1 - i] = hf;
      }
      break;
    }

  dtype |= KCONST;
  vaddr = findentry_name (&dtype, name);
  xdata[vaddr + 1] = count;
  /* add array header */
  xdata[--firstconst] = count;
  xdata[--firstconst] = 1;
}

void compile_const (void)
{
  byte old_dr = declaration_required;
  bool following = TRUE;
  uchar dtype;
  uchar name[IDENTLEN];
  int addr;

  declaration_required = 0;


  while ((lex () == IDENT) && following)
  {
    tokcpy_ident (name);
    dtype = DT (datatype);
    if (dtype == DFPTR)
      serror (22);
    expect ('=');

    if (*prog == '(') /* const array */
    {
      lex (); /* get the '(' */
      read_list (name, dtype);
    }
    else
    {
      if (dtype != DINTEGER)
        serror (27);
      expect_inumber ();
      dtype = DCONSTANT;
      addr = findentry_name (&dtype, name);
      xdata[addr] = lexint;
    }
    if (*prog == ',')
    {
      lex ();
      following = TRUE;
    }
    else
      following = FALSE;
  }
  if (following)
    serror (41);

  declaration_required = old_dr;
}
/* -----------------*/

void compile_for()
{
  cstack_entry i;
  int varpar;
  int var;
  int sign;

  i.type=CFOR;
  i.step=1;
  if (lex()!=IDENT) { serror(4); return; }
  datatype=DT(datatype);
  if (datatype!=DINTEGER) serror(22);
  var=findentry_token(&datatype);
  varpar=(datatype & KREFERENCE)>0;
  if (varpar) serror(66);

  i.var = xdata[var];

  expect ('=');

  comp_exp (DINTEGER); /* initial value */
  ADDCODE (B_ASSIGN); ADDVAL (i.var); /* assign to loop variable */
  i.start = pc; /* entry point for closing loop */

  if (lex () != TO) { serror(75); return; }

  comp_exp (DINTEGER); /* loop end value */

  if (lex () != STEP) putback();
  else
    {
      /* optional STEP : only int constants allowed */
      sign = FALSE;
      if (lex () == '-')
        sign = TRUE;
      else putback ();

      expect_inumber();

      if (sign) i.step=-lexint;
      else i.step=lexint;
      /* step !=0 */
      if (i.step==0)
        {
          serror(38);
          return;
        }
    }
  if (i.step<0) { ADDCODE(B_FORCHECKN); }
  else { ADDCODE(B_FORCHECK); }
  ADDVAL(i.var);
  i.ende=pc; ADDCODEP(nullpc);

  cpush(i);
}

void compile_next()
{
  cstack_entry i;

  i = cpopandtest(CFOR);
  cstack_nextlabel (&i, C_CONTINUE);

  if (i.step==1)
    {
      /* short standard version */
      ADDCODE(B_NEXT); ADDVAL(i.var);
    }
  else
    {
      /* variable step width */
      ADDCODE(B_NEXT2); ADDVAL(i.var); ADDVAL(i.step);
    }
  ADDCODEP(i.start);
  *i.ende.p=pc.c;
  cstack_nextlabel (&i, C_BREAK);
}
/*---------------------------------------------------*/
void compile_if()
{
  /*int op;*/
  cstack_entry cs;

  comp_exp (DBOOLEAN);

  lex ();
  if (tok == THEN)
  {
    cs.type = CIF;
    cs.ende = pc;
    ADDJMP (JMPIFNOT, 0); /* destination unknown */
    cpush (cs);
  }
  else
  {
    if (token_type != TIDENT)
      serror (0);
    switch (look_up (commandtable))
    {
    case GOTO:
      compile_goto (JMPIF);
      break;
    case BREAK:
      compile_break (JMPIF, C_BREAK);
      break;
    case CONTINUE:
      compile_break (JMPIF, C_CONTINUE);
      break;
    default:
      serror (0);
    }
  }

    /*{
      if (token_type!=TIDENT) serror(0);
      op=look_up(commandtable);
      if (op!=GOTO) serror(0);

      compile_goto(JMPIF);
    }*/
}

void compile_else ()
{
  PC ad1;
  cstack_entry cs;
  cs=cpopandtest(CIF);
  ad1=cs.ende;
  cs.ende=pc;
  cpush(cs);
  ADDJMP(JMP,0);/* dummy, address unknown */
  LINKJMP(ad1.c,pc.c);
}

void compile_endif ()
{
  PC ad;
  cstack_entry cs;
  cs=cpopandtest(CIF);
  ad=cs.ende;
  LINKJMP(ad.i,pc.c);
}

/* while .. endwhile */
void compile_while()
{
  cstack_entry cs;
  cs.start=pc;
  comp_exp(DBOOLEAN);

  cs.type=CWHILE;
  cs.ende=pc;
  ADDJMP(JMPIFNOT,0); /* destination unknown */
  cpush(cs);
}

void compile_endwhile()
{
  PC ad;
  cstack_entry cs;
  cs=cpopandtest(CWHILE);
  cstack_nextlabel (&cs, C_CONTINUE);
  ADDJMP(JMP,cs.start.c);
  ad=cs.ende;
  LINKJMP(ad.i,pc.c);
  cstack_nextlabel (&cs, C_BREAK);
}
/* DO .. LOOP - loop */
void compile_do ()
{
  cstack_entry cs;
  cs.start=pc;
  lex();
  if (tok==WHILE)
    {
      /* condition on entry WHILE */
      comp_exp(DBOOLEAN);
      cs.type=CDOC;
      cs.ende=pc;
      ADDJMP(JMPIFNOT,0); /* destination unknown */
    }
  else
    if (tok==UNTIL)
      {
        /* condition on entry UNTIL */
        comp_exp(DBOOLEAN);
        cs.type=CDOC;
        cs.ende=pc;
        ADDJMP(JMPIF,0); /* destination unknown */
      }
    else
      {
        /* condition on end of loop */
        putback();
        cs.type=CDO;
        cs.start=pc;
      }
  cpush(cs);
}

void compile_loop()
{
  PC ad;
  cstack_entry cs;
  cs=cpop();
  cstack_nextlabel (&cs, C_CONTINUE);
  if (cs.type==CDO)
    {
      /* condition must follow here */
      lex();
      if (tok==WHILE)
        {
          comp_exp(DBOOLEAN);
          ADDJMP(JMPIF,cs.start.c);
        }
      else
        if (tok==UNTIL)
          {
            comp_exp(DBOOLEAN);
            ADDJMP(JMPIFNOT,cs.start.c);
          }
        else serror(0);
    }
  else
    if (cs.type==CDOC)
      {
        ADDJMP(JMP,cs.start.c);
        ad=cs.ende;
        LINKJMP(ad.i,pc.c);
      }
    else serror(11);
  cstack_nextlabel (&cs, C_BREAK);
}

/* case keyword */

const unsigned int FAR _case_ofs[] = {
  /*256 = LESS*/        B_OF_B,
                        B_OF_B /* should never be called */,
  /*258 = GREATER*/     B_OF_A,
  /*259 = NOT_LESS*/    B_OF_AE,
                        B_OF_B /* should never be called */,
  /*261 = NOT_GREATER*/ B_OF_BE,
};

void compile_case ()
{
  uchar seltype;
  bool Else;
  int tok2;
  cstack_entry cs;
  /*uchar* old_prog;
  uchar nprog;*/

  lex ();
  if (tok == SELECT)
  {
    /* CASE SELECT */
    comp_exput (&seltype);
    cs.var = seltype;
    if ((seltype != DINTEGER) && (seltype != DBOOLEAN) && (seltype != DCHAR))
      serror (22); /* type mismatch */
    ADDCODE (B_CASE);
    cs.type = CCASE;
    cs.start = pc;
    cs.step = 0;
    cpush (cs);
  }
  else
  {
    if (!(Else = (tok == ELSE)))
      putback();

    cs = cpopandtest (CCASE);
    if (cs.step == 0) /* first CASE statement */
      if (cs.start.c != pc.c)
        serror (0);/* statements outside CASE */

    if (cs.step > 1)
      LINKJMP (cs.ende.i, pc.c); /* "close" previous case */
    if (cs.step > 0)
    {
      cs.ende = pc;
      ADDJMP (JMP, 0);
      *cs.start.p = pc.c;
    }
    if (!Else)
    { /* range checks in case (MB,4.10) */
      lex ();
      switch (tok)
      {
      case GREATER:
      case LESS:
      case NOT_GREATER:
      case NOT_LESS:
        tok2 = tok;
        comp_exp (cs.var);
        ADDCODE (_case_ofs[tok2 - LESS]);
        break;
      case '=':
        comp_exp (cs.var);
        ADDCODE (B_OF_E);
        break;
      default:
        putback ();
        comp_exp (cs.var);
        lex ();
        if (tok == TO)
        {
          comp_exp (cs.var);
          ADDCODE (B_OF_BOUND);
        }
        else
        {
          putback ();
          ADDCODE (B_OF_E);
        }
      }
      cs.start = pc;
      ADDCODEP (nullpc);
    }
    else
      cs.start.i = NULL;
    ++cs.step;
    cpush (cs);
  }
}

void compile_endcase ()
{
  cstack_entry cs;
  cs=cpopandtest(CCASE);
  if (cs.step==0) serror(0);
  if (cs.step>0)
    if (cs.start.i!=NULL) *cs.start.p=pc.c;
  if (cs.step>1) LINKJMP(cs.ende.i,pc.c);
}

/*----------------------------------------------*/
void set_version(void)
{
  int version;

  expect_inumber();
  version = lexint;

  if (version>current_version) serror(73);

  desired_version=version;
  if (version<325)
    {
      default_hash_mode=2;
    }
  if (version<110)
    {
      intchar='#';
      floatchar='%';
    }
}
/*-------------------------------------------------*/
void compile_input()
{
  uchar vtyp;
  int use_addr;
  if (lex() == STRING)
    {
      /* a prompt is given */
      putback();
      comp_exp(DSTRING);
      ADDCODE(B_PRINT_STRING); /* print prompt */
      lex(); /* expect delimiter */
      if (tok != ',' && tok != ';') serror(14);
      lex(); /* get first identifier for input */
    }
  if (tok!=IDENT) serror(4);

  vtyp=datatype;
  comp_var(&vtyp, &use_addr); /* compile variable */
  switch (vtyp)
    {
    case DINTEGER:
      ADDCODE(B_INPUT); ADDCODE(B_ASSIGN_I);
      break;
    case DFLOAT:
      ADDCODE(B_INPUT_F); ADDCODE(B_ASSIGN_F);
      break;
    case DSTRING:
      ADDCODE(B_INPUT_S); ADDCODE(B_ASSIGN_S);
      break;
    default: serror(22);
    }
}
/*-------------------------------------------------*/
int compile_procedure(void)
{
  /* compile a procedure call */
  int found;
  uchar htoken[IDENTLEN];
  uchar version;

  KeywordPr FAR *hptr=proctable;
  /* all normal procedures in proctable */

  tokcpy_ident(htoken);
  /* find entry */
  found=FALSE;
  while ((!found) && (hptr->command!=0))
    {
      found=(strcmp_nf(htoken,hptr->command)==0);
      if (!found) hptr++;
    }
  if (!found) return FALSE;

  /* compile parameters */
  comp_para(hptr->paratype,&version,DELIMITER);
  ADDCODE(hptr->bincode[version]);
  return TRUE;
}

char FAR compiling[]="Compiling: %s";

void CompileMessage(uchar memoname[])
{
#ifndef DEBUGCOMP
  uchar temp[200];
  {
    if (!show_compiling) /* do not show compiling (MB,4.20) */
      return;
    if (memoname == NULL)
      {
        Box (5,20,155,40,10);
      }
    else
        {
          sprintf((char*)temp,Near(compiling),memoname);
          textbox(temp,5,20,155,40,0); /* always font 0 (MB,4.10) */
        }
    LibPutDisp();
  }
#endif
}

bool loadprogmemo()
{
  uchar *sig;
  switch (ITOS.progtype)
    {
    case MMAIN: sig=PROGRAMSIG; break;
    case MINCLUDE: sig=INCLUDESIG; break;
    case MAPPEND: sig=APPENDSIG; break;
    }
  if (ITOS.min!=0)
    return load_memo_named(ITOS.min,sig,ITOS.fname,&ITOS.fp);
  else
    switch(ITOS.progtype)
      {
      case MMAIN:
        ITOS.min=pref.progsub;
        return load_memo_named(pref.progsub,sig,ITOS.fname,&ITOS.fp);
      case MINCLUDE:
        ITOS.min=IncStack[0].min;
        if (load_memo_named(IncStack[0].min,sig,ITOS.fname,&ITOS.fp))
          return TRUE;
        ITOS.min=pref.includesub;
        if (IncStack[0].min!=pref.includesub)
          return load_memo_named(pref.includesub,sig,ITOS.fname,&ITOS.fp);
        else return FALSE;
      case MAPPEND:
        ITOS.min=IncStack[0].min;
        return load_memo_named(IncStack[0].min,sig,ITOS.fname,&ITOS.fp);
      }
}

bool loadprog()
{
#ifndef SMALL_NO_CACHE
  char name[MAXSTRLEN];
#endif

  ITOS.fp = 0;

#ifndef SMALL_NO_CACHE
  if (switches.cacheing && (!save_to_cache) && (!c_ctbl_looked_up))
  { /* search for cached program (MB,4.22) */
    /*LibPutMsgDlg ("loadprog_lookup");*/
    c_csig = name;
    c_cnr = 0;
    cache_getname ();
    c_ctbl_looked_up = TRUE;
    if (cache_load ())
    {
      /*LibPutMsgDlg ("loadprog_cached");*/
      switches.cached = TRUE;
      switches.statistics = FALSE;
      return (TRUE);
    }
  }
#endif

#ifdef REMOTE_CONTROL
  if (switches.remote)
  {
    ITOS.min=0;
    if (rc_loadprog()) return TRUE;
  }
#endif
  return loadprogmemo();
}

#ifndef SMALL_NO_CACHE
/* cacheing functions (MB,4.22) */


void cache_getname (void)
{
  char pbuf[NAMELEN];

  strcpy_nf ((uchar*) pbuf, (uchar FAR*) c_filename);
  sprintf (c_csig, pbuf, c_cnr++, (char*) (progname));
}

void cache_init (void)
{
  cache_getname ();
  fbbinit ();
  fbbputstring ((uchar*) c_csig);
}

#if FALSE
int cache_find (FILE_INFO *fi)
{
  int found = FALSE;
  fi->fp = 0xFFFF;           /* first search */
  fi->kind = FILE_KIND_BIN;  /* binary file */

  while ((!found) && (LibFileFindNext (&fb, fi, 0x00)))
  {
    if (!LibFileReadEx (&fb, fi, CACHE_BUFSIZE / FILE_BLOCK_SIZE))
      return (FALSE); /* Read error */
    found = strcmp ((char*) FBB, c_csig) == 0;
  }

  if (!found)
  {
    fi->fp = 0xFFFF;          /* prepare FILE_INFO for "write new" */
    fi->kind = FILE_KIND_BIN;
  }
  return (found);
}
#endif

int cache_save (void)
{
  FILE_INFO fi;
  FILE_BUF fbuf; /* requires lots of memory! */

  if (!sffindfile (&fb))
    return (FALSE);
  sffindfile (&fbuf);
  sffindrecord ((uchar*) c_csig, &fbuf, &fi);

  FBBNUM = fbptr;
  fbbinit ();

  return (LibFileWrite (&fb, &fi));
}

int cache_load (void)
{
  FILE_INFO fi;

  if (!sffindfile (&fb))
    return (FALSE);
  if (!/*cache_find (&fi)*/ sffindrecord ((uchar*) c_csig, &fb, &fi))
    return (FALSE);

  fbptr = 0;
  while (FBB[fbptr] != 0)
    ++fbptr;
  ++fbptr; /* go after end of signature */

  return (TRUE);
}

/*int cache_lookup (void)
{
  c_cnr = 0;
  return (cache_nextfile (sfLoadRecord, 3072));
}

int cache_nextfile (c_sffunc_t sffunc, int size)
{
  char nmbuf[MAXSTRLEN];
  char pbuf[NAMELEN];

  strcpy_nf (pbuf, c_filename);
  sprintf (nmbuf, pbuf, c_cnr++, (char*) (progname));
  return (sffunc ((uchar*) nmbuf, size, (byte*) (FBB)));
}*/

int cache_geti (void) /* read integer */
{
  int val;

  if (fbptr > CACHE_MAXSIZE)
  {
    /*cache_nextfile (sfLoadRecord, 3072);
    fbbinit ();*/
    cache_getname ();
    cache_load ();
  }
#ifdef LSI_C
  val = *(int*) (FBB + fbptr);
#else
  memcpy (&val, FBB + fbptr, sizeof (int));
#endif
  fbptr += sizeof (int);
  /*++c_cnt;*/
  OutputITrm (val);

  return (val);
}

void cache_puti (int i) /* write integer */
{
  if (fbptr > CACHE_MAXSIZE)
  {
    /*cache_nextfile (sfSaveRecord, fbptr);
    fbbinit ();*/
    cache_save ();
    cache_init ();
  }
#ifdef LSI_C
  *(int*) (FBB + fbptr) = i;
#else
  memcpy (FBB + fbptr, &i, sizeof (int));
#endif
  fbptr += sizeof (int);
  OutputITrm (i);
  /*++c_cnt;*/
}


/*const char cache_cmsg[] = "cw,%s,pos:%i,fbp:%i";*/

void cache_write (void) /* write compiled program to cache */
{
  char name[MAXSTRLEN];
  codet* c_pbin = bin;
  codet* c_pbmax;
  int FAR* c_pxdata = xdata;
  int FAR* c_pxmax;

  int c_tmp;

  c_csig = name;
  c_cnr = 0;
  /*c_cnt = 0;*/

  /*
   * cache file:
   *   uint current_version;
   *   uint binsize, binstart, datanext, firstconst;
   *
   * global variables:
   *   int  tchxi, tchyi, tchobji, tchstsi, pvmodeli, owbversioni;
   *   int  error, inputrc, formstrings, owbparameter;
   *   int  desired_version;
   *
   * program data:
   *   uint bindata[binsize];
   *   int  xdata_var[datanext - 1];
   *   int  xdata_const[DATASIZE - firstconst];
   */

  cache_init ();
  cache_puti (CACHE_VERSION);
  cache_puti (pc.c - bin); cache_puti (bin_start.c - bin);
  cache_puti (datanext); cache_puti (firstconst);

  cache_puti (tchxi); cache_puti (tchyi); cache_puti (tchobji); cache_puti (tchstsi);
  cache_puti (pvmodeli); cache_puti (owbversioni);
  cache_puti (error); cache_puti (inputrc); cache_puti (formstrings); cache_puti (owbparameter);
  cache_puti (desired_version);

  /* write binary data (program codes) */
  for (c_pbmax = pc.c; c_pbin < c_pbmax; cache_puti (*((int*) (c_pbin++))));
  /*LibPutMsgDlg (cache_cmsg, "bin", c_cnt, fbptr);*/

  /* write compressed xdata */
  for (c_pxmax = &xdata[datanext]; c_pxdata < c_pxmax; ++c_pxdata)
  {
    cache_puti (*c_pxdata);
    if (*c_pxdata == 0) /* next number contains amount of following 0s */
    {
      for (c_tmp = 0; (c_pxdata < c_pxmax) && (*c_pxdata == 0); ++c_tmp, ++c_pxdata);
      cache_puti (c_tmp);
      --c_pxdata; /* incremented in outer loop again */
    }
  }
  /*LibPutMsgDlg (cache_cmsg, "xdv", c_cnt, fbptr);*/

  /* write constants in xdata */
  for (c_pxmax = &xdata[DATASIZE], c_pxdata = &xdata[firstconst]; c_pxdata < c_pxmax; cache_puti (*(c_pxdata++)));
  /*LibPutMsgDlg (cache_cmsg, "xdc", c_cnt, fbptr);*/

  /* save last file */
  LibPutMsgDlg ("num:%i", fbptr);
  cache_save ();
}

bool cache_read (void) /* read compiled program from cache */
{
  char name[MAXSTRLEN];
  codet* c_pbin = bin;
  codet* c_pbmax;
  int FAR* c_pxdata = xdata;
  int FAR* c_pxmax;
  int FAR* c_px2;

  int c_tmp;

  c_csig = name;
  /*c_cnt = 0;*/
  c_cnr = 0;

  cache_getname ();
  if (!cache_load ())
    return (FALSE); /* should already be loaded */
    LibPutMsgDlg ("num:%i", FBBNUM);

  /*
   * cache file:
   *   uint current_version;
   *   uint binsize, binstart, datanext, firstconst;
   *
   * global variables:
   *   int  tchxi, tchyi, tchobji, tchstsi, pvmodeli, owbversioni;
   *   int  error, inputrc, formstrings, owbparameter;
   *   int  desired_version;
   *
   * program data:
   *   uint bindata[binsize];
   *   int  xdata_var[datanext - 1];
   *   int  xdata_const[DATASIZE - firstconst];
   */

  if ((c_tmp = cache_geti /* getui */ ()) != CACHE_VERSION)
  {
    LibPutMsgDlg ((char*) "c_r: %i wrong version", c_tmp);
    return (FALSE);
  }

  c_tmp = cache_geti /* getui */ (); bin_start.c = bin + cache_geti /* getui */ ();
  datanext = cache_geti /* getui */ (); firstconst = cache_geti /* getui */ ();

  tchxi       = (int) cache_geti (); tchxp       = &xdata[tchxi];
  tchyi       = (int) cache_geti (); tchyp       = &xdata[tchyi];
  tchobji     = (int) cache_geti (); tchobjp     = &xdata[tchobji];
  tchstsi     = (int) cache_geti (); tchstsp     = &xdata[tchstsi];
  pvmodeli    = (int) cache_geti (); pvmodelp    = &xdata[pvmodeli];
  owbversioni = (int) cache_geti (); owbversionp = &xdata[owbversioni];

  error = cache_geti ();
  inputrc = cache_geti ();
  formstrings = cache_geti ();
  owbparameter = cache_geti ();

  desired_version = cache_geti ();
  if (desired_version < 325)
    default_hash_mode = 2;


  /* read bin data */
  for (c_pbmax = &bin[c_tmp]; c_pbin < c_pbmax; *((int*) (c_pbin++)) = cache_geti /* getui */ ());
  /*LibPutMsgDlg (cache_cmsg, "bin", c_cnt, fbptr);*/

  /* read compressed xdata_var */
  for (c_pxmax = &xdata[datanext]; c_pxdata < c_pxmax; /*++c_pxdata*/)
  {
    c_tmp = cache_geti ();
    if (c_tmp == 0) /*next number contains amount of following 0s */
    {
      for (c_px2 = c_pxdata + cache_geti (); c_pxdata < c_px2; *(c_pxdata++) = 0);
    }
    else
      *(c_pxdata++) = c_tmp;
  }
  /*LibPutMsgDlg (cache_cmsg, "xdv", c_cnt, fbptr);*/

  /* read xdata_const */
  for (c_pxmax = &xdata[DATASIZE], c_pxdata = &xdata[firstconst]; c_pxdata < c_pxmax; *(c_pxdata++) = cache_geti ());
  /*LibPutMsgDlg (cache_cmsg, "xdc", c_cnt, fbptr);*/
  return (TRUE);
}
#endif

int compile(int lastcode)
{
  const uchar pvmodel_str[] = "pvmodel";
  const uchar owbversion_str[] = "owbversion";
  /* compile process */
  int rc, ec;
  uchar datat;
  byte *p_buf = fb.fbuf.text.fsb_text_buf_;

#ifndef SMALL_NO_CACHE
  if (switches.cached)
  {
    if (cache_read ())
      return (FALSE);
    switches.cacheing = FALSE;
    loadprog ();
  }
#endif

  ec = FALSE;
  if (setjmp (errorret))
  {
    CompileMessage (NULL);
    return TRUE;
  }
  prog_start = prog = aprog = p_buf;
  ITOS.line = 1;
  ctos = 0;            /* ForTo stackpointer reset */
  cpp = NULL;            /* no procedure declaration is running */
  last_proc = -1;
  a_overlay = FALSE;        /* not compiling overlay */

  listreset ();

  default_datatype = DINTEGER;/* Default datatype for variables without suffix */
  pc.c = bin;                /* codepointer to start of binary area */
  bin_start.c = bin;         /* start point for interpreter */
  lastpc.c = &bin[lastcode];/* end of code */
  f_stack_ptr.f = f_stack;
  i_stack_ptr = i_stack - 1;    /* i_stack is used as IF stack for compile */

  IncStackPtr = IncStack;


  /* initialize permanent variables: */
  datat = DINTEGER;
  tchxi=xdata[findentry_name(&datat,(uchar*)"tchx")]; /*   - touch screen */
  tchxp=&(xdata[tchxi]);
  tchyi=xdata[findentry_name(&datat,(uchar*)"tchy")];
  tchyp=&(xdata[tchyi]);
  tchobji=xdata[findentry_name(&datat,(uchar*)"tchobj")];
  tchobjp=&(xdata[tchobji]);
  tchstsi=xdata[findentry_name(&datat,(uchar*)"tchsts")];
  tchstsp=&(xdata[tchstsi]);
  error=xdata[findentry_name(&datat,(uchar*)"error")];     /* - error code */
  inputrc=xdata[findentry_name(&datat,(uchar*)"inputrc")]; /* - input return code */

  pvmodeli=xdata[findentry_name(&datat, pvmodel_str)]; /* constants */
  pvmodelp=&(xdata[pvmodeli]);
  *pvmodelp = PV_MODEL;

  owbversioni=xdata[findentry_name(&datat, owbversion_str)];
  owbversionp=&(xdata[owbversioni]);
  *owbversionp = current_version;

  datat = DSTRING;
  formstrings=findentry_name(&datat,(uchar*)"formstrings");
  expandentry(formstrings,MAXFORMELEMENTS,1);
  formstrings=xdata[formstrings];

  owbparameter = findentry_name (&datat, (uchar*) "parameter");
  owbparameter = xdata[owbparameter];


  /* initialize constants: */
  datat = DCONSTANT;
  xdata[findentry_name (&datat, (uchar*)"floatsize")] = sizeof (FLOATT) / sizeof (int);
  xdata[findentry_name (&datat, (uchar*)"null")] = 0;
  xdata[findentry_name (&datat, pvmodel_str)] = pvmodel;
  xdata[findentry_name (&datat, owbversion_str)] = current_version;


  /*
    if (switches.printwhilecomp)
    {
    for (i=0;i<20;i++) OutTrm('\n');
    DisplayTrm();
    }
  */
  CompileMessage(ITOS.fname);
  rc=RC_CONTINUE;
  while (rc!=RC_EXIT)
    {
      rc=compile_command();
      switch(rc)
        {
        case RC_INCLUDE:
          /* handle include */
          ITOS.prog=prog; /* store pointer of compiler */
          IncStackPtr++;
          if (IncStackPtr - IncStack < INCSTACKSIZE) /* include stack not full? */
          {
            /* load new memo ..*/
            ITOS.line=1;
            ITOS.prog=prog=prog_start=aprog=p_buf;
            if (token_type==TIDENT) tokncpy(ITOS.fname,NAMELEN);
            else sconstncpy(ITOS.fname,NAMELEN);
            ITOS.progtype=MINCLUDE;
            ITOS.min=0;
            CompileMessage(ITOS.fname);
            if (!loadprog())
            {
              serror1 (2043, ITOS.fname); /* not found */
            }
          }
          else
            serror (42); /* include stack overflow */
          break;

        case RC_APPEND:
          /* load new memo from program category */
          ITOS.line=1;
          /*  ITOS.min=0; */
          ITOS.progtype=MAPPEND;
          prog_start = aprog = prog = p_buf;
          if (token_type==TIDENT) tokncpy(ITOS.fname,NAMELEN);
          else sconstncpy(ITOS.fname,NAMELEN);
          CompileMessage(ITOS.fname);
          if (!loadprog())
          {
            serror1(2044,ITOS.fname); /* not found */
          }
          break;

        case RC_EXIT:
          /* end of memo */
          if (IncStackPtr>IncStack) /* entry in include stack ? */
          {
            IncStackPtr--; /* restore previous memo */
            aprog=prog=ITOS.prog;
            CompileMessage(ITOS.fname);
            if (ITOS.fp==0)
            {
              loadprog();
            }
            else fileread(3, ITOS.min, ITOS.fp);
            rc=RC_CONTINUE; /* continue compile */
          }
          break;
        }
    }
  /*  if (switches.printwhilecomp) OutTrm('\n');*/

  ADDCODE(B_END0); /* make sure the program doesn't run into undefined code */
  CompileMessage(NULL);
  check_labels ();  /* check if all used labels are defined */
  if (cpp != NULL)
    serror(63); /* open procedure definition */
  if (d_cnt != 1)
    serror (21); /* unclosed .IF */
  if (ctos != 0)
    notclosederror (cstack[ctos-1].type);  /* unclosed control */
  create_variables ();        /* create variables for runtime
                                   (deleting symbols) */
#ifndef SMALL_NO_CACHE
    if (save_to_cache)
      cache_write ();
#endif
  return ec;
}
