#include "modeldef.h"
#include <shared.h>
#include <string.h>
#include "owbasic.h"
#include "comp.h"
#include "rc.h"
/*
  Error messages
*/
char FAR e0[]  = {"Syntax error"};
char FAR e1[]  = {"Unbalanced parenthesis"}; /* 1 */
char FAR e2[]  = {"No expression present"}; /* 2 */
char FAR e3[]  = {"" /*"Integer stack underflow"*/}; /* 3 */
char FAR e4[]  = {"Not a variable"}; /* 4 */
char FAR e5[]  = {"Symbol table full"}; /* 5 */
char FAR e6[]  = {"Double defined label"}; /* 6 */
char FAR e7[]  = {"" /*"Integer stack overflow"*/}; /* 7 */
char FAR e8[]  = {"GOSUB stack underflow"}; /* 8 */
char FAR e9[]  = {"GOSUB stack overflow"}; /* 9 */
char FAR e10[] = {"Too many nested controls"}; /* 10 */
char FAR e11[] = {"Controls unbalanced"}; /* 11 */
char FAR e12[] = {"Too many nested GOSUBs"}; /* 12 */
char FAR e13[] = {"Last code reached"}; /* 13 */
char FAR e14[] = {"Expression delimiter expected"}; /* 14 */
char FAR e15[] = {"No open IF"}; /* 15 */
char FAR e16[] = {"Too many labels"};  /* 16 unused */
char FAR e17[] = {"Unknown function"}; /*17*/
char FAR e18[] = {"No open FOR"}; /* 18 */
char FAR e19[] = {"Expected '<', '>' or '='"};/* 19 */
char FAR e20[] = {"Undefined constant"};/*20*/
char FAR e21[] = {"Unclosed IF"};/*21*/
char FAR e22[] = {"Type mismatch"};/*22*/
char FAR e23[] = {"Unclosed FOR"}; /*23*/
char FAR e24[] = {"Wrong operator"}; /*24*/
char FAR e25[] = {"Float stack underflow"}; /*25*/
char FAR e26[] = {"Float stack overflow"}; /*26*/
char FAR e27[] = {"Not implemented"}; /*27*/
char FAR e28[] = {"Integer number expected"}; /*28*/
char FAR e29[] = {"Array needed"}; /*29*/
char FAR e30[] = {"Index out of range"}; /*30*/
char FAR e31[] = {"Array variable used\rbefore DIM"}; /*31*/
char FAR e32[] = {"String too long"};/*32*/
char FAR e33[] = {"Memory full"};/*33*/
char FAR e34[] = {"String stack underflow"}; /*34*/
char FAR e35[] = {"String stack overflow"}; /*35*/
char FAR e36[] = {"Negative argument"}; /*36*/
char FAR e37[] = {"Label expected"}; /*37*/
char FAR e38[] = {"Wrong parameter"}; /*38*/
char FAR e39[] = {"Failed"}; /*39*/
char FAR e40[] = {"Unknown procedure"}; /*40*/
char FAR e41[] = {"Expected identifier"}; /*41*/
char FAR e42[] = {"Include stack overflow"}; /*42*/
char FAR e43[] = {"Include file not found"}; /*43*/
char FAR e44[] = {"Append file not found"}; /*44*/
char FAR e45[] = {"Error position found"}; /*45*/
char FAR e46[] = {"Too many parameters"}; /*46*/
char FAR e47[] = {"Too less parameters"}; /*47*/
char FAR e48[] = {"Nested procedure"}; /*48*/
char FAR e49[] = {"ENDP without PROC"}; /*49*/
char FAR e50[] = {"PROC or FUNC not at begin"}; /*50*/
char FAR e51[] = {"Too many procedures"}; /*51*/
char FAR e52[] = {"Procedure already exists"}; /*52*/
char FAR e53[] = {"Interrupted"}; /*53*/
char FAR e54[] = {"Undefined label"}; /*54*/
char FAR e55[] = {"Expected constant"}; /*55*/
char FAR e56[] = {"Aborted"}; /*56*/
char FAR e57[] = {"Division by 0"}; /*57*/
char FAR e58[] = {"Wrong mode"}; /*58*/
char FAR e59[] = {"No valid icon"}; /*59*/
char FAR e60[] = {"No more data"}; /*60*/
char FAR e61[] = {"Not found"}; /*61*/
char FAR e62[] = {"File exists"}; /*62*/
char FAR e63[] = {"Missing ENDP"}; /*63*/
char FAR e64[] = {"Arrays must be VAR parameter"}; /*64*/
char FAR e65[] = {"Coordinates out of range"}; /*65*/
char FAR e66[] = {"VAR parameters\rnot allowed here"}; /*66*/
char FAR e67[] = {"Not initialized"}; /*67*/
char FAR e68[] = {"Can't save overlay"}; /*68*/
char FAR e69[] = {"Can't load overlay"}; /*69*/
char FAR e70[] = {"Same overlay"}; /*70*/
char FAR e71[] = {"File too big"}; /*71*/
char FAR e72[] = {"Nesting error"}; /*72*/
char FAR e73[] = {"Wrong version"}; /*73*/
char FAR e74[] = {"Wrong font"}; /*74*/
char FAR e75[] = {"TO expected"}; /*75*/
char FAR e76[] = {"Global variable exist"}; /*76*/
char FAR e77[] = {"Undefined variable"}; /*77*/
char FAR e78[] = {"Invalid procedure\raddress"}; /*78*/
char FAR e79[] = {"Expected constant expression"}; /*79*/

char FAR * (FAR e)[]= {
   e0, e1, e2, e3, e4, e5, e6, e7, e8, e9,
  e10,e11,e12,e13,e14,e15,e16,e17,e18,e19,
  e20,e21,e22,e23,e24,e25,e26,e27,e28,e29,
  e30,e31,e32,e33,e34,e35,e36,e37,e38,e39,
  e40,e41,e42,e43,e44,e45,e46,e47,e48,e49,
  e50,e51,e52,e53,e54,e55,e56,e57,e58,e59,
  e60,e61,e62,e63,e64,e65,e66,e67,e68,e69,
  e70,e71,e72,e73,e74,e75,e76,e77,e78,e79,
};

void serror(int error)
{
  uchar s=0;
  serror1(error,&s);
}

void serrortoken(int error)
{
  *token_end=0;
  serror1(error,(uchar*)token_start);
}

void serror1(int error,const uchar *cptr)
{
  int h;
  int herror;  /* format and content of error message */
  uchar etext[300]; /* composition of error message */
  uchar emsg[40];
  uchar *hprog = prog-5;
  herror=error / 1000;
  /*
    switch (herror & 3)
    0 - normal message
    1 - message "expected ... "
    2 - message with *cptr as text

    herror & 4 - don't show context
  */
  error=error % 1000;

  if ((error==45)&&(!isFindRTE)) error=33;

  etext[0]=0;

  /* program context of error */
  if (((herror & 4)==0)&&(!switches.remote))
    /* not for include file, undefined label;
       not in remote control mode */
    {
      h=0;
      while ((h<20) && (*hprog!='\r') && (hprog>prog_start)) { h++; hprog--; }
      h=0;
      /* text before position */
      while (hprog<prog) etext[h++]=*hprog++;
      /* mark position */
      etext[h++]='_';
      /* fill with following */
      while ((h<29) && (*hprog!=0) && (*hprog!='\r')) etext[h++]=*hprog++;
      etext[h]=0;
    }

  switch (herror & 3)
    {
    case 0: /* simple error without additional text */
      strcpy_nf(emsg,(uchar FAR*)e[error]);
#ifdef REMOTE_CONTROL
      if (!switches.remote)
  {
#endif
    LibPutMsgDlg((byte*)"Line %d %s:\r\r%s\r\r%s",
           ITOS.line, ITOS.fname, emsg, etext);
#ifdef REMOTE_CONTROL
  }
      else
  {
    sprintf((char*)etext,"%s,%d: %s",
      ITOS.fname, ITOS.line, emsg);
    rc_finish(FALSE,etext);
  }
#endif
      break;

    case 1: /* Error expected ...(char or keyword) */
#ifdef REMOTE_CONTROL
      if (!switches.remote)
  {
#endif
    LibPutMsgDlg((byte*)"Line %d %s:\r\rExpected %c (%d)\r\r%s",
           ITOS.line, ITOS.fname, error,error, etext);
#ifdef REMOTE_CONTROL
  }
      else
  {
    sprintf((char*)etext,"%s,%d: Expected %c (%d)",
      ITOS.fname, ITOS.line, error, error);
    rc_finish(FALSE,etext);
  }
#endif
      break;
    case 2: /* Error with *cptr as text */
      strcpy_nf(emsg,(uchar FAR*)e[error]);
#ifdef REMOTE_CONTROL
      if (!switches.remote)
  {
#endif
    LibPutMsgDlg((byte*)"Line %d %s:\r\r%s\r\r>>%s<<\r\r%s",
           ITOS.line, ITOS.fname, emsg, cptr, etext);
#ifdef REMOTE_CONTROL
  }
      else
  {
    sprintf((char*)etext,"%s,%d: %s >>%s<<",
      ITOS.fname, ITOS.line, emsg, cptr);
    rc_finish(FALSE,etext);
  }
#endif

      break;
    }
  longjmp(errorret,1);/* terminate compilation */
}

void rterror(const uchar FAR *funcname,int err)
{
  uchar emsg[40];
  uchar fname[NAMELEN];
#ifdef REMOTE_CONTROL
  uchar msg[40+NAMELEN];
#endif
  unsigned int apc=pc.c-bin;
  strcpy_nf(fname,funcname);
  strcpy_nf(emsg,(uchar FAR*)e[err]);
  if (block_errors==0)
    {
#ifdef REMOTE_CONTROL
      if (switches.remote)
  {
    strncpy((char*)msg,(const char*)fname,40);
    strncat((char*)msg,":",40);
    strncat((char*)msg,(const char *)emsg,40);
    rc_finish(FALSE,msg);
    Restart(STATUS_RC);
  }
      else
  {
#endif
    LibPutMsgDlg((byte*)"Error %s at %d:\r%s",fname,apc, emsg);
    fbbinit();
    fbbputstring(progname);
    fbbputint(apc);
    saveshared((byte*)"rterror",(byte*)PROGNAME,FBB,FBBNUM);
#ifdef REMOTE_CONTROL
  }
#endif
      longjmp(rterrorret,1);
    }
  else xdata[error]=err;
}





