#include <owbasic.h>
#include "comp.h"
#include "ostring.h"

static bool NEAR binop(uchar *ltype,uchar level);
static bool NEAR level5(uchar *ltype);

/* characters for types */
/* for errormessages */
/*uchar typechar[TYPEMASK+1]=".ifslrbc........";*/
uchar typechar[TYPEMASK + 1] = ".ifsbcrl.p......";

/* definition of binary operators */
typedef struct op_ {
  uchar top1; /* type of operand1 */
  int operator1; /* operator (tok from lex()); called operator1 because of parser problems with C++ keyword */
  uchar top2; /* type of operand2 */
  uchar tresult; /* type of result */
  word opcode;
} oper;


typedef oper FAR *operp;

oper FAR ol0[]={
{DBOOLEAN,OR,DBOOLEAN,DBOOLEAN,B_OR_BB},
{DBOOLEAN,XOR,DBOOLEAN,DBOOLEAN,B_XOR_BB},
{DINTEGER,OR,DINTEGER,DINTEGER,B_OR_II},
{DINTEGER,XOR,DINTEGER,DINTEGER,B_XOR_II},
{0,0,0,0,0}};

oper FAR ol1[]={
{DBOOLEAN,AND,DBOOLEAN,DBOOLEAN,B_AND_BB},
{DINTEGER,AND,DINTEGER,DINTEGER,B_AND_II},
{0,0,0,0,0}};

oper FAR ol2[]={
{DFLOAT,GREATER,DFLOAT,DBOOLEAN,B_GREATER_FF},
{DFLOAT,NOT_LESS,DFLOAT,DBOOLEAN,B_NOT_LESS_FF},
{DFLOAT,'=',DFLOAT,DBOOLEAN,B_EQUAL_FF},
{DFLOAT,NOT_GREATER,DFLOAT,DBOOLEAN,B_NOT_GREATER_FF},
{DFLOAT,LESS,DFLOAT,DBOOLEAN,B_LESS_FF},
{DFLOAT,NOT_EQUAL,DFLOAT,DBOOLEAN,B_NOT_EQUAL_FF},

{DFLOAT,GREATER,DINTEGER,DBOOLEAN,B_GREATER_FI},
{DFLOAT,NOT_LESS,DINTEGER,DBOOLEAN,B_NOT_LESS_FI},
{DFLOAT,'=',DINTEGER,DBOOLEAN,B_EQUAL_FI},
{DFLOAT,NOT_GREATER,DINTEGER,DBOOLEAN,B_NOT_GREATER_FI},
{DFLOAT,LESS,DINTEGER,DBOOLEAN,B_LESS_FI},
{DFLOAT,NOT_EQUAL,DINTEGER,DBOOLEAN,B_NOT_EQUAL_FI},

{DINTEGER,GREATER,DFLOAT,DBOOLEAN,B_GREATER_IF},
{DINTEGER,NOT_LESS,DFLOAT,DBOOLEAN,B_NOT_LESS_IF},
{DINTEGER,'=',DFLOAT,DBOOLEAN,B_EQUAL_IF},
{DINTEGER,NOT_GREATER,DFLOAT,DBOOLEAN,B_NOT_GREATER_IF},
{DINTEGER,LESS,DFLOAT,DBOOLEAN,B_LESS_IF},
{DINTEGER,NOT_EQUAL,DFLOAT,DBOOLEAN,B_NOT_EQUAL_IF},

{DINTEGER,GREATER,DINTEGER,DBOOLEAN,B_GREATER_II},
{DINTEGER,NOT_LESS,DINTEGER,DBOOLEAN,B_NOT_LESS_II},
{DINTEGER,'=',DINTEGER,DBOOLEAN,B_EQUAL_II},
{DINTEGER,NOT_GREATER,DINTEGER,DBOOLEAN,B_NOT_GREATER_II},
{DINTEGER,LESS,DINTEGER,DBOOLEAN,B_LESS_II},
{DINTEGER,NOT_EQUAL,DINTEGER,DBOOLEAN,B_NOT_EQUAL_II},

{DSTRING,GREATER,DSTRING,DBOOLEAN,B_GREATER_SS},
{DSTRING,NOT_LESS,DSTRING,DBOOLEAN,B_NOT_LESS_SS},
{DSTRING,'=',DSTRING,DBOOLEAN,B_EQUAL_SS},
{DSTRING,NOT_GREATER,DSTRING,DBOOLEAN,B_NOT_GREATER_SS},
{DSTRING,LESS,DSTRING,DBOOLEAN,B_LESS_SS},
{DSTRING,NOT_EQUAL,DSTRING,DBOOLEAN,B_NOT_EQUAL_SS},

{DCHAR,GREATER,DSTRING,DBOOLEAN,B_GREATER_CS},
{DCHAR,NOT_LESS,DSTRING,DBOOLEAN,B_NOT_LESS_CS},
{DCHAR,'=',DSTRING,DBOOLEAN,B_EQUAL_CS},
{DCHAR,NOT_GREATER,DSTRING,DBOOLEAN,B_NOT_GREATER_CS},
{DCHAR,LESS,DSTRING,DBOOLEAN,B_LESS_CS},
{DCHAR,NOT_EQUAL,DSTRING,DBOOLEAN,B_NOT_EQUAL_CS},

{DSTRING,GREATER,DCHAR,DBOOLEAN,B_GREATER_SC},
{DSTRING,NOT_LESS,DCHAR,DBOOLEAN,B_NOT_LESS_SC},
{DSTRING,'=',DCHAR,DBOOLEAN,B_EQUAL_SC},
{DSTRING,NOT_GREATER,DCHAR,DBOOLEAN,B_NOT_GREATER_SC},
{DSTRING,LESS,DCHAR,DBOOLEAN,B_LESS_SC},
{DSTRING,NOT_EQUAL,DCHAR,DBOOLEAN,B_NOT_EQUAL_SC},

{DCHAR,GREATER,DCHAR,DBOOLEAN,B_GREATER_CC},
{DCHAR,NOT_LESS,DCHAR,DBOOLEAN,B_NOT_LESS_CC},
{DCHAR,'=',DCHAR,DBOOLEAN,B_EQUAL_CC},
{DCHAR,NOT_GREATER,DCHAR,DBOOLEAN,B_NOT_GREATER_CC},
{DCHAR,LESS,DCHAR,DBOOLEAN,B_LESS_CC},
{DCHAR,NOT_EQUAL,DCHAR,DBOOLEAN,B_NOT_EQUAL_CC},

{DBOOLEAN,'=',DBOOLEAN,DBOOLEAN,B_EQUAL_BB},
{DBOOLEAN,NOT_EQUAL,DBOOLEAN,DBOOLEAN,B_NOT_EQUAL_BB},
{0,0,0,0,0}};

oper FAR ol3[]={
{DINTEGER,'-',DINTEGER,DINTEGER,B_SUB_II},
{DINTEGER,'+',DINTEGER,DINTEGER,B_ADD_II},
{DINTEGER,'+',DFLOAT,DFLOAT,B_ADD_IF},
{DINTEGER,'-',DFLOAT,DFLOAT,B_SUB_IF},
{DFLOAT,'+',DINTEGER,DFLOAT,B_ADD_FI},
{DFLOAT,'-',DINTEGER,DFLOAT,B_SUB_FI},
{DFLOAT,'+',DFLOAT,DFLOAT,B_ADD_FF},
{DFLOAT,'-',DFLOAT,DFLOAT,B_SUB_FF},
{DSTRING,'+',DSTRING,DSTRING,B_ADD_SS},
{DCHAR,'+',DSTRING,DSTRING,B_ADD_CS},
{DSTRING,'+',DCHAR,DSTRING,B_ADD_SC},
{DCHAR,'+',DCHAR,DSTRING,B_ADD_CC},
{0,0,0,0,0}};

oper FAR ol4[]={
{DINTEGER,'*',DINTEGER,DINTEGER,B_MUL_II},
{DINTEGER,'/',DINTEGER,DINTEGER,B_DIV_II},
{DINTEGER,'%',DINTEGER,DINTEGER,B_MOD_II},
{DFLOAT,'*',DINTEGER,DFLOAT,B_MUL_FI},
{DFLOAT,'/',DINTEGER,DFLOAT,B_DIV_FI},
{DINTEGER,'*',DFLOAT,DFLOAT,B_MUL_IF},
{DINTEGER,'/',DFLOAT,DFLOAT,B_DIV_IF},
{DFLOAT,'*',DFLOAT,DFLOAT,B_MUL_FF},
{DFLOAT,'/',DFLOAT,DFLOAT,B_DIV_FF},
{0,0,0,0,0}};

oper FAR ol5[]={
{DINTEGER,'^',DINTEGER,DINTEGER,B_POW_II},
{DFLOAT,'^',DINTEGER,DFLOAT,B_POW_FI},
{0,0,0,0,0}};

operp FAR oliste[] = { ol0, ol1, ol2, ol3, ol4, ol5, NULL };

PC apc;
/*static int use_addr;*/

void conv (uchar *tist, uchar tsoll, PC lpc)
{
  int i;

  if (*tist == DINTEGER)
  {
    if (tsoll == DFLOAT)  /* automatic conversion INT -> FLOAT for operand on stack */
    {
      if (lpc.c) /* is_number */
      {
        pc = lpc;
        i = getint (pc);
        ADDCODE (B_IMM_F);
        ADDVALF ((FLOATT) i);
      }
      else
      {
        ADDCODE (B_CONV_IF);
      }
      *tist = DFLOAT;
    }
    else if (tsoll == DFPTR)  /* automatic conversion INT -> FPTR for operand on stack */
      *tist = DFPTR;
  }
  else if (*tist == DCHAR)
  {
    if (tsoll == DSTRING)  /* automatic conversion CHAR -> STRING for operand on stack */
    {
      ADDCODE (B_CONV_CS);
      *tist = DSTRING;
    }
  }
  else if (*tist == DFPTR)
  {
    if (tsoll == DINTEGER)  /* automatic conversion FPTR -> INT for operand on stack */
      *tist = DINTEGER;
  }
}

/* entry points into expression parser */
bool comp_exput (uchar *ltype)
{  /* expression parser with unknown type, type is returned */
  bool is_number;

  lex ();
  if (tok == DELIMITER)
    serror(2); /* empty expression */
  is_number = binop (ltype, 0);
  putback ();
  return (is_number);
}

bool comp_exp (uchar wtype)
{
  bool is_number;
  PC lpc;

  /* expression parser with given type */
  uchar errorstr[] = "a->b";
  uchar ltype = DUNKNOWN;

  lpc = pc;
  is_number = comp_exput (&ltype);
  if (!is_number)
    lpc.c = NULL;
  conv (&ltype, wtype, lpc); /* impicit conversion if neccesary */
  if (wtype != ltype)  /* check type */
  {
    errorstr[3] = typechar[wtype];
    errorstr[0] = typechar[ltype];
    serror1 (2022, errorstr);
  }
  return (is_number);
}

/* --------------------- */

int isoperator(int operator1,uchar level)
{
  /* is given operator an operator of the level level */
  operp op;
  op=oliste[level];
  while (op->operator1!=0)
    {
      if (op->operator1==operator1)
  return TRUE;
      op++;
    }
  return FALSE;
}

int operatorcode(uchar top1,uchar top2,int operator1,uchar level,
     uchar *tres,int *bcode)
{
  /* find operator/operand combination in level level, return result type
     and operation code */
  operp op;
  op=oliste[level];
  while (op->operator1!=0)
    {
      if ((op->operator1==operator1)&&
    (op->top1==top1)&&
    (op->top2==top2))
  {
    *tres=op->tresult;
    *bcode=op->opcode;
    return TRUE;
  }
      op++;
    }
  return FALSE;
}

#ifdef NEVER_DEFINED
static void NEAR binop(uchar *ltype,uchar level)
{
  /* binary operators */
  uchar top2;
  int oper;
  int opcode;
  uchar errorstr[8] = "L0(a,b)";


  if (oliste[level] == NULL)
    level5 (ltype);
  /* lowest level (highest number) reached -> simple operand */
  else
  {
    binop (ltype, level + 1); /* first operand */
    while (isoperator (tok, level)) /* follows valid operator ? */
    {
      oper = tok;         /* store operator for later use */
      lex ();
      binop (&top2, level + 1); /* second operand */
      if (!operatorcode (*ltype, top2, oper, level,
            ltype, &opcode))
      {
        errorstr[1] = level + '0';
        errorstr[3] = typechar[*ltype];
        errorstr[5] = typechar[top2];
        serror1 (2022, errorstr);
      }

      ADDCODE (opcode);
    }
  }
}
#else

int getint (PC p)
{
  switch (*(p.c))
  {
  case B_IMM:
    return (*((int*) (p.c + 1)));
  case B_IMM0:
    return (0);
  case B_IMM1:
    return (1);
  case B_IMM2:
    return (2);
  case B_IMMM1:
    return (-1);
  }
}

static bool NEAR binop (uchar *ltype, uchar level)
{
  /* binary operators */
  uchar top1, top2;
  int oper;
  int opcode;
  codet code;
  bool bopl, bopr;
  PC op1, op2;

  uchar errorstr[8] = "L0(a,b)";


  if (oliste[level] == NULL)
    return (level5 (ltype));  /* lowest level (highest number) reached -> simple operand */
  else
  {
    op1 = pc;
    bopl = binop (ltype, level + 1); /* first operand */
    top1 = *ltype;
    while (isoperator (tok, level)) /* follows valid operator ? */
    {
      oper = tok;         /* store operator for later use */
      lex ();
      op2 = pc;
      bopr = binop (&top2, level + 1); /* second operand */
      if (!operatorcode (*ltype, top2, oper, level,
            ltype, &opcode))
      {
        errorstr[1] = level + '0';
        errorstr[3] = typechar[*ltype];
        errorstr[5] = typechar[top2];
        serror1 (2022, errorstr);
      }

      if (bopl && bopr
       && (((top1 == DINTEGER) || (top1 == DBOOLEAN) || (top1 == DFLOAT))
       &&  ((top2 == DINTEGER) || (top2 == DBOOLEAN) || (top2 == DFLOAT))))
      { /* compile time evaluation (MB,4.40) */
        pc = op1;
        GETCODEPC (code);
        ftable[code] (); /* push 1st operand */
        GETCODEPC (code);
        ftable[code] (); /* push 2nd operand */
        ftable[opcode] (); /* execute operator function */

        pc = op1;
        if ((datatype = *ltype) == DFLOAT)
          lexfloat = fpop ();
        else
          lexint = ipop ();
        comp_number ();
      }
      else
      {
        bopl = FALSE;
        ADDCODE (opcode);
      }
    }
  }
  return (bopl);
}
#endif


static bool NEAR cte_unary (PC cpc, uchar rtype)
{ /* compile time evaluation (MB,4.40) */
  codet code;

  pc = cpc;
  GETCODEPC (code);
  ftable[code] (); /* push operand */
  GETCODEPC (code);
  ftable[code] (); /* execute operator function */

  pc = cpc;
  if ((datatype = rtype) == DFLOAT)
    lexfloat = fpop ();
  else
    lexint = ipop ();
  comp_number ();
}

static bool NEAR level5(uchar *ltype)
{
  /*int sl,il;
  uchar FAR *fp;
  uchar *np;
  bool esc;*/

  PC cpc = pc;
  int vop = '+';
  bool neg = FALSE;
  int use_addr;
  uchar is_number = FALSE;
  uchar hdtype = DUNKNOWN;


  if (tok == NOT)
  {
    neg = TRUE;
    lex ();
  }
  if (tok == '+' || tok == '-')
  {
    vop = tok;
    lex ();
  }
  hdtype = datatype;

  if (tok == '(')
  {
    is_number = comp_exput (&hdtype);
    expect (')');
    lex ();
  }
  else
  {
    /* primitive */
    switch (token_type)
    {
    case TKEY:
      switch (tok)
      {
      case FILEBUFFER:
        expect('[');
        comp_exp(DINTEGER);
        expect(']');
        ADDCODE (B_FBGET);
        hdtype = DINTEGER;
        break;
      case CLIPBOARD:
        expect('[');
        comp_exp(DINTEGER);
        expect(']');
        ADDCODE (B_CBGET);
        hdtype = DINTEGER;
        break;
      case PROP_FBBSIZE:
        ADDCODE (B_GETFBBSIZE);
        hdtype = DINTEGER;
        break;
      case True:
      case False:
        ADDCODE ((tok == True) ? B_IMM1 : B_IMM0);
        is_number = TRUE;
        hdtype = DBOOLEAN;
        break;
      default: serror(0);
      }
      break;
    case TIDENT:
      if (*prog=='(')
      {
        /* function call */
        if (!compile_userprocedure (&hdtype))
        {
          if (!(use_addr = compile_function (&hdtype)))
            serrortoken (2017);
          if (use_addr & 0x02)
            is_number = TRUE;
        }
      }
      else
      {
        comp_var (&hdtype, &use_addr);
        if ((use_addr == 0) || (use_addr == 2))
        {
          switch (hdtype)
          {
          case DCHAR: /* treat char variables like integers */
          case DBOOLEAN: /* treat boolean variables like integers */
          case DINTEGER:
          case DFPTR:
            if (apc.c)
              *apc.c = B_GETVAR; /* overwrite B_IMM */
            else
              ADDCODE (B_GETVARI);
            break;
          case DFLOAT:
            if (apc.c)
              *apc.c = B_GETVAR_F; /* overwrite B_IMM */
            else
              ADDCODE (B_GETVARI_F);
            break;
          case DSTRING:
            if (apc.c)
              *apc.c = B_GETVAR_S; /* overwrite B_IMM */
            else
              ADDCODE(B_GETVARI_S);
            break;
          default: serror(22);
          }
          apc.c = NULL;
        }
      }

      if (hdtype == DSTRING)
      { /* possibly single character */
        if (lex () == '{')
        {
          comp_exp (DINTEGER);
          ADDCODE (B_GETCHAR);
          expect ('}');
          hdtype = DCHAR;
        }
        else
          putback ();
      }
      break;

    case TSTRING:
      ADDCODE (B_IMM_S);
      comp_str ();
      ADDVAL (firstconst);
      hdtype = DSTRING;
      break;

    case TCHAR:
      ADDCODE (B_IMM);
      ADDVAL (tok);
      hdtype = DCHAR;
      break;

    case TNUMBER:
      is_number = TRUE;
      comp_number ();
      hdtype = datatype;
      break;

    default:
      serror (0);
    }
    lex ();
  }


  if (vop == '-')
  {
    switch (hdtype)
    {
    case DINTEGER: ADDCODE(B_NEG); break;
    case DFLOAT: ADDCODE(B_NEG_F); break;
    default: serror(22);
    }
    if (is_number)
      cte_unary (cpc, hdtype);
  }
  if (neg)
  {
    switch (hdtype)
    {
    case DBOOLEAN:
      ADDCODE (B_NOT);
      break;
    case DINTEGER:
      ADDCODE (B_NOT_I);
      break;
    default:
      serror (22);
    }
    if (is_number)
      cte_unary (cpc, hdtype);
  }
  *ltype = hdtype;

  return (is_number);
}

void comp_number (void)
{
  switch (datatype)
  {
  case DBOOLEAN:
  case DINTEGER:
    switch (lexint)
    {
    case 0:
      ADDCODE (B_IMM0);
      break;
    case 1:
      ADDCODE (B_IMM1);
      break;
    case 2:
      ADDCODE (B_IMM2);
      break;
    case -1:
      ADDCODE (B_IMMM1);
      break;
    default:
      ADDCODE (B_IMM);
      ADDVAL (lexint);
    }
    break;
  case DFLOAT:
    ADDCODE (B_IMM_F);
    ADDVALF (lexfloat);
    break;
  }
}
void comp_str (void)
{
  char hex[3] = {0, 0, 0};
  int sl, il, i;
  uchar FAR *fp;
  uchar *np;
  bool esc;

  sl = token_end - token_start - 2;
  il = (sl + sizeof(int)) / sizeof (int);
  firstconst -= il;
  fp = (uchar FAR*) &(xdata[firstconst]);
  np = token_start + 1;
  esc = FALSE;

  while (np < token_end - 1)
  {
    if (esc)
    {
      if (tolower (*np) == 'x')
      {
        hex[0] = *(++np);
        hex[1] = *(++np);
        sscanf (hex, "%x", &i);
        *(fp++) = i;
      }
      else
        *(fp++) = *np;
      esc = FALSE;
    }
    else
    {
      if (*np == '\\')
      {
        esc = TRUE;
      }
      else
        if (*np == NEWLINESYMBOL)
          *(fp++) = NEWLINE;
        else
          *(fp++) = *np;
    }
    ++np;
  }
  *fp = 0;
}

int comp_addr1(uchar *ltype)
{
  /* compile the address of a variable */
  int var;
  /* lex() has read identifier already */
  var = findentry_token (ltype); /* find variable */
  apc.c = NULL;
  if (*ltype & KREFERENCE)
  {
    if (((lex_ref == 2) || (lex_ref == 3)) && (*prog == '['))
    {
      ADDCODE (B_IMM);
      ADDVAL (xdata[var]); /* put runtime address to stack */
      lex ();
      comp_exp (DINTEGER);
      ADDCODE (B_ADD_II);
      ADDCODE (B_GETVARI);
      expect (']');
    }
    else
    {
      ADDCODE (B_GETVAR);
      ADDVAL (xdata[var]); /* put runtime address to stack */
    }
  }
  else
  {
    /* "normal" var */
    apc = pc;   /* until now it's a constant expression (the address) */
    ADDCODE (B_IMM);
    ADDVAL (xdata[var]); /* put addr to stack */
  }
  return (var);
}

int comp_varaddr (uchar* ltype) /* compile address of a reference variable */
{
  int var;

  *ltype |= KREFERENCE;
  var = findentry_token (ltype);
  if (!((*ltype) & KREFERENCE))
    serror (4);
  *ltype = DINTEGER | KREFERENCE;
  ADDCODE (B_IMM);
  ADDVAL (xdata[var]); /* put runtime address to stack */
  if (*prog == '[')
  {
    lex ();
    comp_exp (DINTEGER);
    ADDCODE (B_ADD_II);
    expect (']');
  }
  return (var);
}

void comp_varindex (uchar* ltype /*, int use_addr*/)
{
  int use_addr = (*ltype & KREFERENCE) && !(*ltype & KARRAY);

  if (lex () == '[') /* array element */
  {
    /*if (((*ltype & KREFERENCE)>0)&&((*ltype & KARRAY)==0)) serror(29);*/ /* allow indexing variables (MB,4.20) */

    apc.c = NULL;
    comp_exp (DINTEGER); /* put index on stack */
    if ((*prog == ',') && (!use_addr))
    {
      lex(); /* skip ',' */
      comp_exp(DINTEGER);
      switch (*ltype & TYPEMASK)
      {
      case DCHAR:
      case DBOOLEAN:
      case DINTEGER:
      case DSTRING:
      case DFPTR:
        ADDCODE (B_ARRAY2_ADDR);
        break;
      case DFLOAT:
        ADDCODE(B_ARRAY2_ADDR_F);
        break;
      /*case DSTRING:
        ADDCODE(B_ARRAY2_ADDR_S);
        break;*/
      }
    }
    else
    {
      switch (*ltype & TYPEMASK)
      {
      case DCHAR:
      case DBOOLEAN:
      case DINTEGER:
      case DSTRING:
      case DFPTR:
        ADDCODE (use_addr ? B_ADD_II : B_ARRAY_ADDR);
        break;
      case DFLOAT:
        ADDCODE (use_addr ? B_NOCHK_ARRAY_ADDR_F : B_ARRAY_ADDR_F);
        break;
      /*case DSTRING:
        ADDCODE(use_addr ? B_NOCHK_ARRAY_ADDR_S : B_ARRAY_ADDR_S);

        break;*/
      }
    }
    expect (']');
  }
  else
    putback ();
}

void comp_var (uchar *ltype, int* use_addr)
{
  *use_addr = lex_ref;
  /* lex() has read identifier already */

  if (token_type != TIDENT)
    serror (41);

  if (*use_addr == 4)
    comp_varaddr (ltype);
  else
  {
    comp_addr1 (ltype);
    if ((*use_addr >= 0) && (*use_addr <= 2))
      comp_varindex (ltype);
  }
  if (*use_addr > 0)
    *ltype = DINTEGER;
  else
    *ltype &= TYPEMASK;
}


void comp_array(uchar *ltype)
{
  int var;
  /* lex() has read identifier already */
  if (token_type!=TIDENT) serror(41);
  var = comp_addr1(ltype); /* find entry and store addr */
  /*if (((*ltype & KREFERENCE)>0)&&((*ltype & KARRAY)==0)) serror(29);*/ /* allow indexing variables (MB,4.20) */
  *ltype &= TYPEMASK;
}

void comp_para(uchar FAR *para,uchar *version,int delim)
     /* compile parameter for procedure and function calls */
{
  int i;
  int ltok;
  int use_addr;
  uchar typ;
  uchar xtype;
  i=0; /* first parameter */
  ltok=lex();
  while ((para[i]!=DUNKNOWN) /* not end of parameter list */
   &&(ltok!=delim)     /* not (normal) delimiter */
   &&(ltok!=END))      /* not end of source */
  {
    putback();
    if (i!=0) expect(',');
    typ=para[i] & TYPEMASK;
    if (para[i] & KREFERENCE)    /* Var parameter */
    {
      lex();
      xtype=datatype;
      /* call by reference */
      if (para[i] & KARRAY)
      {
        /* array */
        comp_array(&xtype);
      }
      else
      {
        /* normal variable */
        comp_var(&xtype, &use_addr);
      }
      if (xtype!=typ) serror(22);
    }
    else
      /* call by value */
      comp_exp(typ);
    i++;
    ltok=lex();
  }

  if (delim==')')
    {
      if (ltok!=')') serror(46);
    }
  else
    {
      if ((ltok!=delim)&&(ltok!=END)) serror(46);
    }

  if ((para[i]!=DUNKNOWN) &&
      ((para[i]& KLAST)==0)) serror(47);

  *version=0;
  while (para[i]!=DUNKNOWN)
    {
      if ((para[i]&KLAST)!=0) (*version)++;
      i++;
    }
}

int compile_function (uchar *ltype)
{
  bool is_number = FALSE;
  int found;
  int lookup;
  uchar hdtyp, atyp;
  uchar fname[IDENTLEN];
  uchar version;
  KeywordFn FAR *hptr = functable;

  hdtyp = DT (datatype);
  tokcpy_ident (fname);
  lookup = look_up (keyfunctable);
  expect ('(');

  switch (lookup)
  {
  case F_INT:
    is_number = comp_exput (&atyp);
    switch (atyp)
    {
    case DFLOAT:   is_number = FALSE; ADDCODE (B_CONV_FI); break;
    case DSTRING:  is_number = FALSE; ADDCODE (B_CONV_SI); break;
    case DCHAR:    is_number = FALSE; ADDCODE (B_CONV_CI); break;
    case DFPTR:
    case DBOOLEAN: /*serror (22);*/ break; /* allow casting from bool to int (MB,4.10) */
    case DINTEGER: if (desired_version > 250) serror (22); break;
    default:       serror (22);
    }
    hdtyp = DINTEGER;
    expect (')');
    break;

  case F_FLOAT:
    is_number = comp_exput (&atyp);
    switch (atyp)
    {
    case DBOOLEAN: /* serror(22); break; */ /* allow casting from bool to float (MB,4.10) */
    case DINTEGER: is_number = FALSE; ADDCODE(B_CONV_IF); break;
    case DSTRING:  is_number = FALSE; ADDCODE(B_CONV_SF); break;
    case DFLOAT:   if (desired_version > 250) serror(22); break;
    default:       serror (22);
    }
    hdtyp = DFLOAT;
    expect (')');
    break;

  case F_STRING:
    is_number = FALSE;
    comp_exput (&atyp);
    switch (atyp)
    {
    case DINTEGER: ADDCODE (B_CONV_IS); break;
    case DFLOAT:   ADDCODE (B_CONV_FS); break;
    case DBOOLEAN: ADDCODE (B_CONV_BS); break;
    case DCHAR:    ADDCODE (B_CONV_CS); break;
    case DSTRING:  if (desired_version > 250) serror (22); break;
    default:       serror(22);
    }
    hdtyp = DSTRING;
    expect (')');
    break;

  case F_CHAR:
    is_number = comp_exp (DINTEGER);
    switch (hdtyp)
    {
    case DINTEGER:
      hdtyp = DCHAR;
    case DCHAR:   break;
    case DSTRING: is_number = FALSE; ADDCODE (B_CHAR_S); break;
    default:      serror (22);
    }
    expect (')');
    break;

  case F_ASC:
    is_number = comp_exput (&atyp);
    switch (atyp)
    {
    case DCHAR:   break;
    case DSTRING: is_number = FALSE; ADDCODE (B_ASC_S); break;
    default:      serror (22);
    }
    hdtyp = DINTEGER;
    expect (')');
    break;

  case F_ARRAYSIZE:
    lex ();
    comp_array (&datatype);
    if (*prog == ',')
    {
      lex (); /* skip ',' */
      comp_exp (DINTEGER);
      ADDCODE (B_ARRAYSIZE);
    }
    else
    {
      ADDCODE (B_ARRAYSIZE1);
    }
    hdtyp = DINTEGER;
    expect (')');
    break;

  case F_CALL:
    is_fptrcall = TRUE;
    compile_userprocedure (&hdtyp); /* ')' is removed by compile_userprocedure */
    break;

  case F_PROC:
  case F_FUNC:
    is_number = TRUE;
    lex ();
    if (lookup == F_FUNC)
      datatype = DT (datatype);
    tokcpy_ident (fname);
    if ((lookup = search_procfunc (fname, datatype)) == -1)
      serrortoken (2040); /* Unknown Procedure */

    ADDCODE (B_IMM);
    ADDVAL ((int) (proc_table[lookup].addr.c));
    hdtyp = DFPTR;
    expect (')');
    break;

  case D_VARDEF:
    is_number = TRUE;
    lex ();
    lexint = (searchentry_token (&datatype) < 0) ? 0 : 1;
    datatype = DBOOLEAN;
    hdtyp = datatype = DBOOLEAN;
    comp_number ();
    expect (')');
    break;

  case D_PROCFUNCDEF:
    is_number = TRUE;
    lex ();
    tokcpy_ident (fname);
    lexint = (search_procfunc (fname, datatype) < 0) ? 0 : 1;
    hdtyp = datatype = DBOOLEAN;
    comp_number ();
    expect (')');
    break;

  default:
    found = FALSE;
    /* alle normalen Funktionen in KeywordFn */
    while ((!found) && (hptr->command != NULL))
    {
      if ((hptr->rtype == hdtyp) && (strcmp_nf (fname, hptr->command) == 0))
      {
        /* gefunden */
        /* Parameter auswerten */
        comp_para (hptr->paratype, &version, ')');
        /* Funktionsaufruf */
        ADDCODE (hptr->bincode[version]);
        found = TRUE;
      }
      else
        ++hptr;
    }
    if (!found)
      return (FALSE);
  }

#if FALSE
  if (strcmp_nf(fname,FN_INT)==0) {
    comp_exput(&atyp);
    switch (atyp)
      {
      case DFLOAT: ADDCODE(B_CONV_FI); break;
      case DSTRING: ADDCODE(B_CONV_SI); break;
      case DBOOLEAN: /*serror(22);*/ break; /* allow casting from bool to int (MB,4.10) */
      case DINTEGER: if (desired_version>250) serror(22); break;
      case DCHAR: ADDCODE(B_CONV_CI); break;
      default: serror(22);
      }
    hdtyp=DINTEGER;
    expect(')');
  }
  else
    if (strcmp_nf(fname,FN_FLOAT)==0) {
      comp_exput(&atyp);
      switch (atyp)
  {
  case DBOOLEAN: /* serror(22); break; */ /* allow casting from bool to float (MB,4.10) */
  case DINTEGER: ADDCODE(B_CONV_IF); break;
  case DSTRING: ADDCODE(B_CONV_SF); break;
  case DFLOAT: if (desired_version>250) serror(22); break;
  default: serror(22);
  }
      hdtyp=DFLOAT;
      expect(')');
    }
    else
      if (strcmp_nf(fname,FN_STRING)==0) {
  comp_exput(&atyp);
  switch (atyp)
    {
    case DINTEGER: ADDCODE (B_CONV_IS); break;
    case DFLOAT:   ADDCODE (B_CONV_FS); break;
    case DBOOLEAN: ADDCODE (B_CONV_BS); break;
    case DCHAR:    ADDCODE (B_CONV_CS); break;
    case DSTRING:  if (desired_version > 250) serror (22); break;
    default: serror(22);
    }
  hdtyp=DSTRING;
  expect(')');
      }
      else
      if (strcmp_nf(fname,FN_ASC)==0) {
  comp_exput(&atyp);
  switch (atyp)
  {
  case DCHAR: break;
  case DSTRING: ADDCODE (B_ASC_S); break;
  default: serror (22);
  }
  hdtyp=DINTEGER;
  expect(')');
      }
      else
      if (strcmp_nf(fname,FN_CHAR)==0) {
  comp_exp(DINTEGER);
  hdtyp=DCHAR;
  expect(')');
      }
      else
  if (strcmp_nf(fname,FN_ARRAYSIZE)==0)
    {
      lex();
      comp_array(&datatype);
      if (*prog==',')
        {
    lex(); /* skip ',' */
    comp_exp(DINTEGER);
    ADDCODE(B_ARRAYSIZE);
        }
      else
        {
    ADDCODE(B_ARRAYSIZE1);
        }
      hdtyp=DINTEGER;
      expect(')');
    }
  else
    {
      found=FALSE;
      /* alle normalen funktionen in KeywordFn */
      while ((!found)&&(hptr->command!=NULL))
        {
    if ((hptr->rtype==hdtyp)&&(strcmp_nf(fname,hptr->command)==0))
      {
        /* gefunden */
        /* parameter auswerten */
        comp_para(hptr->paratype,&version,')');
        /* Funktionsaufruf */
        ADDCODE(hptr->bincode[version]);
        found=TRUE;
      }
    else hptr++;
        }
      if (!found)
        {
    return FALSE;
        }
    }
#endif
  *ltype = hdtyp;
  if (is_number)
    return (3);
  return (1);
}
