#include <owbasic.h>
#include "inter.h"
#include <graphic.h>

#ifdef LSI_C
/* int vramsegment;*/
#endif

void x_messagebox(void)
{
  int mode=ipop();
  switch(mode)
    {
    case 0: LibPutMsgDlg(STOS); break;
    case 1: LibPutMsgDlg4(STOS); break;
    case 2: LibPutMsgDlg2(STOS); break;
    case 4: LibPutMsgDlg3(STOS);
    case 3: LibPutMsgDlg3(STOS); break;
    }
  spop1();
}

void x_messagebox1(void)
{
  LibPutMsgDlg(STOS);
  spop1();
}

/*------------------------------------*/
void x_show0(void) { LibPutDisp(); }
void x_show(void) {
  int x1,y1,x2,y2;
  y2=ipop(); x2=ipop(); y1=ipop(); x1=ipop();
  LibPutDispBox(x1,y1,x2-x1+1,y2-y1+1);
}

/*-------------- runtime functions ----------------------*/
#ifndef LSI_C
void x_pset(void)
{
  int x,y,z;
  z=ipop(); y=ipop(); x=ipop();
  if (checkxy(x,y)) psetfunc[z & DRAWMODEMASK](x,y);
  else rterror(FN_PSET,65);
}
#endif

void x_pset2(void)
{
  ipush(1);
  x_pset();
}

void x_line(void)
{
  int x1,y1,x2,y2,z;
  int rc;
  z=ipop();

  y2=ipop(); x2=ipop(); y1=ipop(); x1=ipop();
  if (z==0) z=2;
  rc=Line(x1,y1,x2,y2,z);

  if (rc!=0) rterror(FN_LINE,rc);
}

void x_line4(void)
{
  ipush(1); x_line();
}

void x_ellipse(void)
{
  int xm,ym,rx,ry,z;
  int rc;
  z=ipop();

  ry=ipop(); rx=ipop(); ym=ipop(); xm=ipop();
  if (z==0) z=2;
  rc=Ellipse(xm,ym,rx,ry,z);

  if (rc!=0) rterror(FN_ELLIPSE,rc);
}

void x_ellipse4(void)
{
  ipush(1); x_ellipse();
}

void x_circle(void)
{
  int xm,ym,r,z;
  int rc;
  z=ipop();

  r=ipop(); ym=ipop(); xm=ipop();
  if (z==0) z=2;
  rc=Ellipse(xm,ym,r,r,z);

  if (rc!=0) rterror(FN_CIRCLE,rc);
}

void x_circle3(void)
{
  ipush(1); x_circle();
}

void x_box(void)
{
  int rc;
  rc=Box(ST4,ST3,ST2,ST1,TOS);
  if (rc!=0) rterror(FN_BOX,rc);
  ipopn(5);
}

void x_box4(void)
{
  ipush(1);
  x_box();
}

void x_igraph(void)
{
  if (checkxy(ST1,TOS)) LibPutFarData(ST1,TOS,ST2);
  else rterror(FN_IGRAPH,65);
  ipopn(3);
}

void x_scroll (void) /* SCROLL x1%, y1%, x2%, y2%, diff% (MB,4.20) */
{
  int x1, y1, x2, y2;
  int diff;

  diff = ipop ();
  y2  = ipop (); x2 = ipop ();
  y1  = ipop (); x1 = ipop ();

  if (!checkxy2 (x1, y1, x2, y2))
  {
    rterror (FN_SCROLL, 65);
    return;
  }
  x2 -= x1;
  y2 -= y1;
  ++x2; ++y2;
  if (diff < 0)
    LibGrpUp (x1, y1, x2, y2, -diff);
  if (diff > 0)
    LibGrpDwn (x1, y1, x2, y2, diff);
}

void x_stringsize(void)
{
  int font, l;
  font=ipop();
  l=stringsize(STOS,font);
  ipush(l);
  spop1();
}

void x_stringheight(void)
{
  int font, l;
  font=ipop();
  l=stringheight(STOS,font);
  ipush(l);
  spop1();
}

void x_drawstring (void) /* DRAWSTRING str$, x%, y% [,mode%=0] [,maxr%=159] (MB,4.24) */
{
  int x, y, xl, font;
  int rc;
  xl = ipop (); font = ipop (); y = ipop (); x = ipop ();
  rc = drawstring (STOS, x, y, font, xl);
  if (rc)
    rterror (FN_DRAWSTRING, rc);
  spop1 ();
}

void x_drawstring4 (void)
{
  ipush (159);
  x_drawstring ();
}

void x_drawstring3 (void)
{
  ipush (IB_PFONT1);
  ipush (159);
  x_drawstring ();
}

void x_drawicon (void) /* DRAWICON BM%[], x%, y% [, mode%=0] (MB,4.20) */
{
  int addr, x, y;
  int rc, mode;
  mode = ipop (); y = ipop (); x = ipop (); addr = ipop ();
  rc = drawicon (addr, x, y, mode);

  if (rc)
    rterror (FN_DRAWICON, rc);

  /* bk_counter=0;*/
}

void x_drawicon3 (void)
{
  /*int addr, x, y;
  int rc;
  y = ipop (); x = ipop (); addr = ipop ();
  rc = drawicon (addr, x, y, 0);

  if (rc)
    rterror (FN_DRAWICON, rc);*/

  /* bk_counter=0;*/
  ipush (0);
  x_drawicon ();
}


void x_geticon(void)
{
  int x1,y1, x2,y2;
  int aaddr;
  int rc;
  y2=ipop(); x2=ipop();
  y1=ipop(); x1=ipop();
  aaddr=ipop();
  rc=geticon(aaddr,x1,y1,x2,y2);

  if (rc!=0) rterror(FN_GETICON,rc);
  /*  bk_counter=0;*/
}

void x_seticonpix(void)
{
  int aa,ox,oy,val;
  int bm;
  int FAR *p;
  int size;
  val=ipop(); oy=ipop(); ox=ipop(); aa=ipop(); /* read parameter */
  size=xdata[aa-1];
  if (! checkicon(aa,size)) rterror(FN_SETICONPIX,59);
  if (! iconaddr(&(xdata[aa]),ox,oy,&bm,&p)) rterror(FN_SETICONPIX,30);
  if (val) *p |= bm;
  else *p &= ~bm;
}

void x_iconpix(void)
{
  int aa,ox,oy,val;
  int bm;
  int FAR *p;
  int size;
  oy=ipop(); ox=ipop(); aa=ipop(); /* read parameter */
  size=xdata[aa-1];
  if (! checkicon(aa,size)) rterror(FN_ICONPIX,59);
  if (! iconaddr(&(xdata[aa]),ox,oy,&bm,&p)) rterror(FN_ICONPIX,30);
  val=*p & bm ? 1:0;
  ipush(val);
}

void x_resizeicon(void)
{
  int darraysize;
  int sarraysize;
  int h;
  int xd, yd;
  int x1, y1, x2, y2;
  int fx, fy;
  int ssx, ssy;
  int sbm, dbm;
  int FAR *sptr;
  int FAR *dptr;
  int x, y;
  int bm;
  int FAR*p;
  int val;

  y2=ipop(); x2=ipop(); /* source window lr */
  y1=ipop(); x1=ipop(); /* source window ul */
  yd=ipop(); xd=ipop(); /* destination size */
  dbm=ipop(); /* destination bitmap */
  sbm=ipop(); /* source bitmap */
  sptr=&(xdata[sbm]);
  dptr=&(xdata[dbm]);
  darraysize=xdata[dbm-1];
  sarraysize=xdata[sbm-1];
  if (darraysize<2) rterror(FN_RESIZEICON,59);/*can't be enough for an icon*/
  xdata[dbm]=xd; xdata[dbm+1]=yd;
  if (! checkicon(dbm,darraysize)) rterror(FN_RESIZEICON,59);/*check size*/

  if (! checkicon(sbm,sarraysize)) rterror(FN_RESIZEICON,59);/*check size*/
  ssx=xdata[sbm]; ssy=xdata[sbm+1]; /* source size */
  if ((xd<=0)||(yd<=0)) rterror(FN_RESIZEICON,38);

  if (x1>x2) { h=x1;x1=x2;x2=h; }
  if (y1>y2) { h=y1;y1=y2;y2=h; }
  if ((x1<0)||(y1<0)||(x2>=ssx)||(y2>=ssy)) rterror(FN_RESIZEICON,30);

  fx=(x2-x1+1)/xd; fy=(y2-y1+1)/yd;
  if ((fx>0)||(fy>0))
    {
      /* destination is smaller */
      for (y=0;y<yd;y++)
        for (x=0;x<xd;x++)
          {
            iconaddr0(sptr,x*fx+x1,y*fy+y1,&bm,&p);
            val=*p & bm ? 1 : 0;
            iconaddr0(dptr,x,y,&bm,&p);
            if (val) *p |= bm;
            else *p &= ~bm;
          }
    }
  else
    {
      fx=xd/(x2-x1+1); fy=yd/(y2-y1+1);
      if ((fx==0)||(fy==0)) rterror(FN_RESIZEICON,38);
      else
        {
          /* destination is bigger */
          for (y=0;y<yd;y++)
            for (x=0;x<xd;x++)
              {
                iconaddr0(sptr,x/fx+x1,y/fy+y1,&bm,&p);
                val=*p & bm ? 1 : 0;
                iconaddr0(dptr,x,y,&bm,&p);
                if (val) *p |= bm;
                else *p &= ~bm;
              }
        }
    }
}

void x_resizeicon4(void)
{
  int xd, yd;
  int ssx, ssy;
  int sbm, dbm;

  yd=ipop(); xd=ipop(); /* destination size */
  dbm=ipop(); /* destination bitmap */
  sbm=ipop(); /* source bitmap */
  ssx=xdata[sbm]; ssy=xdata[sbm+1]; /* source size */
  if ((xd<=0)||(yd<=0)) rterror(FN_RESIZEICON,38);
  ipush(sbm);
  ipush(dbm);
  ipush(xd); ipush(yd);
  ipush(0); ipush(0);
  ipush(ssx-1); ipush(ssy-1);
  x_resizeicon();
}

void x_inrange(void)
{
  int x,x1,x2;
  x2=ipop(); x1=ipop(); x=ipop();
  ipush(inrange(x,x1,x2));
}

void x_inside(void)
{
  int x,x1,x2;
  int y,y1,y2;
  y2=ipop();  x2=ipop();
  y1=ipop();  x1=ipop();
  y=ipop();  x=ipop();
  ipush(inrange(x,x1,x2)&&inrange(y,y1,y2));
}

void x_insideg(void)
{
  int x;
  int y;
  y=ipop(); x=ipop();
  ipush(checkxy(x,y));
}

#ifdef LSI_C
#if FALSE
bool CheckSeg(int addr)
{
  unsigned char FAR *vramptr;
  vramptr=MK_FP(addr,0x0000);
  LibDotOn(0,0); LibDotOff(1,0);
  LibDotOn(2,0); LibDotOff(3,0);
  LibDotOn(4,0); LibDotOff(5,0);
  LibDotOn(6,0); LibDotOff(7,0);
  if (*vramptr!=0xAA) return FALSE;
  LibDotOff(0,0); LibDotOff(2,0);
  if (*vramptr!=0x0A) return FALSE;
  return TRUE;
}

int DetectVideoRam(void)
{
  if (CheckSeg(0x100)) return 0x100;
  return 0;
}
#endif
#endif

#ifdef __HITACHI__
void x_pixel()
{
  const byte mask[]={128,64,32,16,8,4,2,1};
  int y=ipop();
  int x=TOS;
  int xh=x & 0xF8;
  int xl=x & 0x7;
  if (checkxy(x,y))
    {
      LibGetGraph(xh,y,8,1,iconbuffer);
      TOS=iconbuffer[0]&mask[xl] ? 1 : 0;
    }
  else TOS=0;
}
#endif


#define TOUCHED_SCREEN(x1,y1,x2,y2) ((*tchxp >= x1) && (*tchxp <= x2)  \
                                  && (*tchyp >= y1) && (*tchyp <= y2))
const static signed char _iinput_nr[] = {'7', '8', '9', '4', '5', '6', '1', '2', '3', '0', -1, -2};
void x_inputi (void) /* INPUTI VAL% (MB,4.24) */
{
  int save[330];
  char sval[30];
  char buf[30];
  bool exit = FALSE;
  bool changed = FALSE;
  char i = 0;
  int vali = ipop ();

  save[0] = 58; save[1] = 82;
  LibGetGraph (0, 78, 58, 82, (byte FAR*) (save + 2)); /* save screen area */
  LibPutFarData (0, 89, 181); /* numeric keyboard */

  LibPutProStr (IB_PFONT1, 24, 132, (byte*) "+-", 40);
  LibPutProStr (IB_PFONT1, 46, 131, (byte*) "x", 60);

  sprintf (sval, (char*) "%d", xdata[vali]);

  do
  {
    Box (0, 78, 57, 88, 1012);
    LibPutProStr (IB_PFONT1, 55 - LibGetProStrSize (IB_PFONT1, (uchar*) sval), 80, (byte*) sval, 55);
    if (!changed)
    {
      sval[0] = '0';
      sval[1] = '\0';
    }
    LibPutDisp ();

    while (!check_touch ());
    newtouched = FALSE;

    if (TOUCHED_SCREEN (0, 143, 28, 159))
    {
      changed = TRUE;
      sval[0] = '0';
      sval[1] = '\0';
    }
    else if (TOUCHED_SCREEN (29, 143, 57, 159))
    {
      if (changed)
        xdata[vali] = atoi (sval);
      break;
    }
    else if (TOUCHED_SCREEN (0, 89, 56, 140))
    {
      changed = TRUE;
      i = _iinput_nr[(*tchyp - 89) / 13 * 3 + (*tchxp / 19)];
      if (i == -2)
        exit = TRUE;
      else if (i == -1)
        sprintf (sval, "%d", -atoi (sval));
      else
      {
        sprintf (buf, "%s%c", sval, i);
        sprintf (sval, "%d", atoi (buf));
      }
    }

  } while (!exit);

  LibPutGraph (0, 78, (byte FAR*) save); /* restore graphics */
}


void x_inputs (void) /* INPUTS STR$ [, prompt$] (MB,4.40) */
{
  char str[MAXSTRLEN];
  int addr;

  addr = ipop ();
  getvar (addr, str);

  strinpbkg (STOS);
  spop1 ();

  if (inputstr (str, 2, 12, 157, 8, IB_PFONT1, MAXSTRLEN - 1) != TRM_ESC)
    putvar (addr, str);
}

void x_inputs1 (void)
{
  spush1 ();
  x_inputs ();
}
