#include <string.h>

#include <stdlib.h>

#include "modeldef.h"
#include "shared.h"
#include "owbasic.h"
#include "graphic.h"
#include "trm.h"
#include "comp.h"

#undef tolower

SLW2_ST Menu;
byte *lastname;
byte rv[20];
byte itemnumber;

/* Additional topics for menus */
#define T_PROGRAMMENU 1
#define T_FILEMENU 2
#define T_OPTIONS 4

#define MNAMELEN 30
#define ARROW "\xd0"

typedef struct _pmenuentry {
  int cat;
  uchar name[MNAMELEN];
} pmenuentry;

typedef struct _pmenu {
  uchar name[MNAMELEN];
  pmenuentry prog[8];
} pmenu;

static void NEAR confprogmenu(int mnr);

/*
 low level menu functions
*/

static void NEAR menuinit(void)
{
  Menu.x = 5;   /* menu position */
  Menu.y = 0;
  Menu.xs = 10; /* width */
  Menu.ity = 12; /* linespacing */
  Menu.np = 0;  /* first highlighted item */
  Menu.cmnt = (byte*)&bin; /* use binary program memory here */
  Menu.rtv = rv;
  Menu.t_xs = 3;
  itemnumber=0;
  lastname = (byte*)&bin;
  *bin=0;
  rv[0]=0xff;
}

static void NEAR menuitem(uchar *tp,byte ret,bool high)
{
  int width;
  byte *ptr,*src;
  width=LibGetProStrSize(IB_PFONT1,tp)+10;
  if (width>150) width=150;
  if (Menu.xs < width) Menu.xs=width;
  rv[itemnumber]=ret;
  if (high) Menu.np=itemnumber;
  itemnumber++;
  rv[itemnumber]=0xff;
  ptr=lastname;
  if (itemnumber>1) *ptr++=0xfe;

  src=tp;
  while (*src!=0) *(ptr++)=*(src++);
  *ptr=0;

  lastname=ptr;
}

char FAR on[]=" (on)";
char FAR off[]=" (off)";

static void NEAR menuitemsw(uchar *tp,byte ret,bool onoff)
{
  uchar tt[50];
  strncpy((char*)tt,(char*)tp,40);
  if (onoff) strcat((char*)tt,Near(on));
  else strcat((char*)tt,Near(off));
  menuitem(tt,ret,FALSE);
}

static int NEAR menusel(int allowabort)
{
  int rc;
  if (itemnumber==0) return 255; /* empty menu -> abort */

  Menu.x=(159-Menu.xs)/2; /* menu position x (from longest string) */
  if (Menu.x<0) Menu.x=0; /* if string too long ..*/
  Menu.ity=140/itemnumber; /* possible distance in y direction */
  if (Menu.ity>15) Menu.ity=15; /* no more than 15 (not nice) */
  Menu.y=(150-Menu.ity*itemnumber)/2+8; /* y position (centered) */

  do
    {
      rc=LibSelWindowExt(&Menu);
    } while ((!allowabort)&&(rc==255));
  return rc;
}

void fbuffer2name(uchar *name)
{
  byte *p=fb.fbuf.text.fsb_text_buf_;
  byte *hp=name;
  int i=2;
  while ((i < (MNAMELEN - 1) /*23*/)&&(p[i]!='\r')&&(p[i]!=0)) {*(hp++)=p[i]; i++;}
  *hp=0;
  trim(name);
}

int fp2name(byte sub,word fp,uchar *name)
{
  SetFP(3,sub,fp);
  if (!LibFileRead(&fb,&finf)) return FALSE;
  fbuffer2name(name);
  return TRUE;
}

/*
  Special menufunctions
*/

#define MAXFP 500
static word NEAR selmemo(int cat,int topics,byte *sig)
{
  /* select memo */
  byte fstring[NAMELEN]="";
  byte *p=fb.fbuf.text.fsb_text_buf_;
  byte name[25];
  word fp[MAXFP];
  int files;
  int anr,nr,snr;
  int sel;
  int mfiles;

  mfiles=9;
  if (topics & T_OPTIONS) mfiles--;
  if (topics & T_PROGRAMMENU) mfiles--;

  sel=-1;
  while (sel<0)
    {
      /* collect all files */
      SetFP(3,cat,0xffff);

      files=0;
      while (LibFileFindNext(&fb,&finf,0x00)&&(files<MAXFP))
  {
    if (LibFileRead(&fb,&finf))
      {
        if ((sig==NULL)||(strncmp((char*)p,(char*)sig,2)==0))
    /* valid signature ? */
    {
      if (fstring[0]!=0)
        {
          fbuffer2name(name);
          strlower(name);
          if (pos(fstring,name)>=0)
      {
        fp[files]=finf.fp;
        files++;
      }
        }
      else
        {
          fp[files]=finf.fp;
          files++;
        }
    } /* if signature */
      } /* if read */
    fb.fsb_sub_entry_  = cat & 0xf;  /* restore Sub */
  } /* while */

      if ((files==0)&&(topics==0)) return 0xffff;
      snr=0;
      sel=-1;
      while (sel==-1)
  {
    menuinit();
    if (topics & T_OPTIONS)
      menuitem((uchar*)ARROW "Options",254,TRUE); /* item preferences */
    menuitem((uchar*)ARROW "Filter",250,FALSE); /* file filter */
    if (snr>0)  menuitem((uchar*)ARROW "Previous",251,FALSE);
    anr=snr;
    nr=0;
    while (nr<mfiles)
      {
        if (anr<files)
    {
      fp2name(cat,fp[anr],name);
      menuitem(name,anr,FALSE);
    }
        nr++; anr++;
      }
    if (anr<files) menuitem((uchar*)ARROW "Next",252,FALSE);
    if (topics & T_PROGRAMMENU) menuitem((uchar*)ARROW "Programmenu",253,FALSE);
    LibClrDisp();
    sel= menusel(TRUE);

    if (sel==255) return 0xffff; /* aborted */
    if (sel==254) return 0xfffe; /* options */
    if (sel==253) return 0xfffd; /* programmenu */
    if (sel==252) /* down */
      {
        snr+=7;
        if (snr>=files) snr=files-1;
        sel=-1;
      }

    if (sel==251) /* up */
      {
        snr-=7;
        if (snr<0) snr=0;
        sel=-1;
      }
    if (sel==250) /* filter */
      {
        sel=-2;
        OutTrm(0x0c);
        OutputTrm((uchar*)"Filter mask:\r");
        InputTrm(fstring,NAMELEN);
        strlower(fstring);
      }
  }
    }
  return fp[sel];
}

char FAR all_free[]="All (free)";
char FAR category[]="category %d";
char FAR m_free[]="%s (free)";
char FAR all_secret[]="All (secret)";
char FAR secret[]="%s (secret)";

static int NEAR selcategory(byte *prompt,int def,bool allow_all)
{
  /* selection of a category */
  byte name[25],name1[16];
  int i;
  int sel;
  LibClrDisp();
  LibStringDsp(prompt,5,5,175,1);
  menuinit();
  /* open area */
  if (allow_all) menuitem((uchar*)Near(all_free),0,0==def);
  for (i=1;i<6;i++)
    {
      LibLblAreaRead(name1,i+4);
      if (name1[0]==0) sprintf((char*)name1,Near(category),i);
      sprintf((char*)name,Near(m_free),name1);
      menuitem(name,i,i==def);
    }

  /* secret area */
  if (allow_all) menuitem((uchar*)Near(all_secret),16,16==def);
  for (i=1;i<6;i++)
    {
      LibLblAreaRead(name1,i+4);
      if (name1[0]==0) sprintf((char*)name1,Near(category),i);
      sprintf((char*)name,Near(secret),name1);
      menuitem(name,i+16,i+16==def);
    }
  sel=menusel(FALSE);
  return sel;
}

char FAR wait_after[]="Wait after end?";
char FAR no_wait[]="No wait";
char FAR silent_wait[]="Silent wait";
char FAR wait_message[]="Wait with message";

static void NEAR selwait(void)
{
  LibStringDsp((byte*)Near(wait_after),5,5,175,1);
  menuinit();
  menuitem((uchar*)Near(no_wait),0, pref.finalwait==0);
  menuitem((uchar*)Near(silent_wait),1,pref.finalwait==1);
  menuitem((uchar*)Near(wait_message),2,pref.finalwait==2);
  pref.finalwait= menusel(FALSE);
}

char FAR configure_submenu[]="Configure submenu";
char FAR change_name[]="Change name";
char FAR configure_entries[]="Configure entries";
char FAR m_exit[]="Exit";
char FAR m_name[]="Name: ";

static void NEAR confsubmenu(int place,pmenu *pm)
{
  int i;
  do {
    LibStringDsp((byte*)Near(configure_submenu),5,5,175,1);
    LibStringDsp((byte*)pm->prog[place-1].name,5,20,175,1);
    menuinit();
    menuitem((uchar*)Near(change_name),0,FALSE);
    menuitem((uchar*)Near(configure_entries),1,FALSE);
    menuitem((uchar*)Near(m_exit),2,TRUE);
    i=menusel(FALSE);
    switch(i)
      {
      case 0: OutputTrm((uchar*)Near(m_name));
  InputTrm((uchar*)pm->prog[place-1].name,MNAMELEN-1); /* input name */
  break;
      case 1: confprogmenu(place); /* configure submenu */
  break;
      }
  } while (i!=2);
}

char FAR configure_menu[]="Configure menu";
char FAR m_abort[]="Abort";
char FAR m_save[]="Save";
char FAR m_program[]="Program";
char FAR m_submenu[]="Submenu";
char FAR m_delete[]="Delete";

static void NEAR confprogmenu(int mnr)
{
  byte ready;
  int i, place, place1;
  uchar mname[MNAMELEN];
  /*uchar name2[MNAMELEN];*/
  pmenu pm;
  word fp;

  sprintf((char*)mname,PROGNAME ",menu%d",mnr);

  if (!sfLoadRecord(mname,sizeof(pm),(byte*)&pm))
    {
      /* default empty menu */
      pm.name[0]=0;
      for (i=0;i<8;i++)
  {
    pm.prog[i].cat=0;
    pm.prog[i].name[0]=0;
  }
    }
  ready=FALSE;
  do {
    LibClrDisp();
    LibStringDsp((byte*)Near(configure_menu),5,5,175,1);
    LibStringDsp((byte*)pm.name,5,25,175,1);
    menuinit();                   /* create menu */
    menuitem((uchar*)Near(m_abort),100,FALSE);  /* additional entries */
    menuitem((uchar*)Near(m_save),101,FALSE);
    for (i=0;i<8;i++)             /* progmenu places */
      {
  if (pm.prog[i].cat==100)
    sprintf((char*)mname,"%d (" ARROW "%s)",i+1,pm.prog[i].name);
  else
    sprintf((char*)mname,"%d %s",i+1,pm.prog[i].name);
  menuitem(mname,i+1,FALSE);
      }
    place=menusel(TRUE);
    if ((place>0)&&(place<9))
      {
  place1=place-1;
  LibClrDisp();
  menuinit();
  menuitem((uchar*)Near(m_program),1,FALSE);
  if (mnr==0) menuitem((uchar*)Near(m_submenu),2,FALSE);
  menuitem((uchar*)Near(m_delete),3,FALSE);
  i=menusel(TRUE);
  switch (i)
    {
    case 1:
      pm.prog[place1].cat=selcategory((uchar*)"Category",pref.progsub,FALSE);
      if (pm.prog[place1].cat!=255)
        {
    fp=selmemo(pm.prog[place1].cat,0,PROGRAMSIG);
    if (fp==0xffff)
      {
        LibPutMsgDlg3((byte*)"No File");
      }
    else
      {
        fp2name(pm.prog[place1].cat,fp,pm.prog[place1].name);
      }
        }
      else
        {
    pm.prog[place1].cat=0; pm.prog[place1].name[0]=0;
        }
      break;
    case 2:
      /* configure entry as submenu */
      if (pm.prog[place1].cat!=100)
        {
    /* was program */
    pm.prog[place1].name[0]=0; /* erase name */
        }
      pm.prog[place1].cat=100;
      if (strlen((char*)pm.prog[place1].name)==0) /* name exists? */
        {
    OutputTrm((uchar*)"Name:");
    InputTrm(pm.prog[place1].name,MNAMELEN-1); /* input name */
          /*strinpbkg (Near (m_name));
          strcpy (name2, pm.prog[place1].name);
          if (inputstr (name2, 2, 12, 157, 8, IB_PFONT1, MNAMELEN - 1) != TRM_ESC)
            strcpy (pm.prog[place1].name, name2);*/
        }
      confsubmenu(place1+1,&pm);
      break;
    case 3:
      pm.prog[place1].cat=0;      /* delete entry */
      pm.prog[place1].name[0]=0;
      break;
    }
      }
    else ready=TRUE;
  } while (!ready);
  if (place==101)
    {
      sprintf((char*)mname,PROGNAME ",menu%d",mnr);
      if (!sfSaveRecord(mname,sizeof(pm),(byte*)&pm))
  LibPutMsgDlg((byte*)"Saving failed");
    }
}

char FAR m_smenusel[] = "Select initial menu";
char FAR m_smenuprog[] = "Start with programmenu";
char FAR m_smenufile[] = "Start with filemenu";

static void NEAR initialmenu(void)
{
  LibStringDsp(Near (m_smenusel) /*(byte*)"Select initial menu"*/,5,5,175,1);
  menuinit();
  menuitem(Near (m_smenuprog) /*(uchar*)"Start with programmenu"*/,M_PROGRAM,(pref.startmenu==M_PROGRAM));
  menuitem(Near (m_smenufile) /*(uchar*)"Start with filemenu"*/,M_FILE,(pref.startmenu==M_FILE));
  pref.startmenu=menusel(FALSE);
}

#if FALSE
static void NEAR inputlast(void)
{
  uchar str[80];
  OutputTrm((uchar*)"Enter error address:\n");
  if (InputTrm(str,80)==TRM_ESC) return;
  switches.last=atoi((char*)str);
  /*  switches.printwhilecomp=TRUE;*/
}
#endif

char FAR m_sw_stat[] = "Show statistics";
char FAR m_sw_wait[] = "Final wait";
char FAR m_sw_confirm[] = "Confirm ESC";
char FAR m_sw_delovl[] = "Delete overlays";
char FAR m_sw_autorun[] = "Autorun";
char FAR m_sw_restart[] = "Restart";
char FAR m_sw_serror[] = "Search Error";
char FAR m_sw_caching[] = "Caching";
char FAR m_sw_save[] = "Save";
char FAR m_sw_abort[] = "Abort";

static void NEAR switchesmenu(void)
{
  int sel;
  sel=0;
  while (sel==0)
    {
      LibClrDisp();
      menuinit();
      menuitemsw(Near (m_sw_stat) /*(uchar*)"Show statistics"*/,3,pref.statistics);
      /*menuitemsw((uchar*)"Show program",4,switches.printwhilecomp);*/
      menuitem(Near (m_sw_wait) /*(uchar*)"Final wait"*/,5,FALSE);
      menuitemsw(Near (m_sw_confirm) /*(uchar*)"Confirm ESC"*/,6,pref.askabort);
      menuitemsw(Near (m_sw_delovl) /*(uchar*)"Delete overlays"*/,9,pref.clearoverlay);
      menuitemsw(Near (m_sw_autorun) /*(uchar*)"Autorun"*/,10, pref.autorun);
      menuitemsw(Near (m_sw_restart) /*(uchar*)"Restart"*/,11,pref.restart);
      menuitemsw(Near (m_sw_serror) /*(uchar*)"Search Error"*/,12,pref.rterror);
#ifndef SMALL_NO_CACHE
      menuitemsw(Near (m_sw_caching) /*(uchar*)"Caching"*/,20, pref.cacheing);
#endif
      menuitem(Near (m_sw_save) /*(uchar*)"Save"*/,98,TRUE);
      menuitem(Near (m_sw_abort) /*(uchar*)"Abort"*/,99,FALSE);

      sel=menusel(TRUE);
      switch (sel)
  {
  case 3:
    pref.statistics=!pref.statistics;
    switches.statistics=pref.statistics;
    sel=0;
    break;
    /*	case 4:
    switches.printwhilecomp=!switches.printwhilecomp; sel=0; break;*/
  case 5: selwait(); sel=0; break;
  case 6: pref.askabort=!pref.askabort; sel=0; break;
  case 9: pref.clearoverlay=!pref.clearoverlay; sel=0; break;
  case 10: pref.autorun=!pref.autorun; sel=0; break;
  case 11: pref.restart=!pref.restart; sel=0; break;
  case 12: pref.rterror=!pref.rterror; sel=0; break;
#ifndef SMALL_NO_CACHE
  case 20:
    if (!(pref.cacheing && !switches.cacheing))
      switches.cacheing = !switches.cacheing;
    pref.cacheing = !pref.cacheing;
    sel = 0;
    break;
#endif
  case 98: savesettings(); break;
  case 255: /* menu aborted */
  case 99: /* item abort */
    loadsettings();/* restore old values */
    break;
  }
    }
}

char FAR m_pr_ctprog[] = "Program category";
char FAR m_pr_ctincl[] = "Include category";
char FAR m_pr_switches[] = "Switches";
char FAR m_pr_pmcfg[] = "Program menu config";
char FAR m_pr_init[] = "Initial menu";
char FAR m_pr_frterror[] = "Find runtime error";
char FAR m_pr_remote[] = "Enter remote mode";
char FAR m_pr_cache[] = "Cache program";

int prefsmenu(void)
{
  int sel;
  sel=0;
  while (sel==0)
    {
      LibClrDisp();
      menuinit();
      menuitem(Near (m_pr_ctprog) /*(uchar*)"Program category"*/,1,FALSE);
      menuitem(Near (m_pr_ctincl) /*(uchar*)"Include category"*/,2,FALSE);
      menuitem(Near (m_pr_switches) /*(uchar*)"Switches"*/,3,FALSE);
      menuitem(Near (m_pr_pmcfg) /*(uchar*)"Program menu config"*/,7,FALSE);
      menuitem(Near (m_pr_init) /*(uchar*)"Initial menu"*/,8,FALSE);
      if (!pref.rterror)
  menuitem(Near (m_pr_frterror) /*(uchar*)"Find runtime error"*/,10,FALSE);
#ifndef __HITACHI__
      menuitem(Near (m_pr_remote) /*(uchar*)"Enter remote mode"*/,11,FALSE);
#endif
#ifndef SMALL_NO_CACHE
      menuitem (Near (m_pr_cache) /*(uchar*) "Cache program"*/, 20, FALSE);
#endif
      menuitem(Near (m_sw_save) /*(uchar*)"Save"*/,98,TRUE);
      menuitem(Near (m_sw_abort) /*(uchar*)"Abort"*/,99,FALSE);

      sel=menusel(TRUE);
      switch (sel)
  {
  case 1:
    /* select program category */
    pref.progsub=selcategory((uchar*)"Select program category",pref.progsub,TRUE);
    sel=0;
    break;
  case 2:
    /* select include category */
    pref.includesub=selcategory((uchar*)"Select include category",pref.includesub,TRUE);
    sel=0;
    break;
  case 3: switchesmenu(); sel=0; break;
  case 7: confprogmenu(0); sel=0; break;
  case 8: initialmenu(); sel=0; break;
  case 10: Restart(STATUS_FIND_RTE); break;
  case 11: Restart(STATUS_RC); break;
  case 20: Restart (STATUS_CACHE); break;
  case 98: savesettings(); break;
  case 255: /* menu aborted */
  case 99: /* item abort */
    loadsettings();/* restore old values */
    break;
  }
    }
  return 0;
}

int filemenu()
{
  word fps;
  fps=selmemo(pref.progsub,T_PROGRAMMENU|T_OPTIONS,PROGRAMSIG);

  if (fps==0xffff) {
    LibPutMsgDlg((byte*)"Selection aborted");
    LibJumpMenu();
    return FALSE;
  }

  if (fps==0xfffe) { return M_PREFS; }
  if (fps==0xfffd) { return M_PROGRAM; }

  ITOS.min=pref.progsub;
  fp2name(pref.progsub,fps,ITOS.fname);
  return M_READY;
}

int programmenu()
{
  byte ready;
  int mnr=0;
  int i, place;
  uchar mname[MNAMELEN];
  pmenu pm;

  ready=FALSE;

  while (!ready)
    {
      sprintf((char*)mname,PROGNAME ",menu%d",mnr);
      if (!sfLoadRecord(mname,sizeof(pm),(byte*)&pm))
  {
    if (mnr==0) /* no programmenu available */
      {
        return M_FILE;
      }
    else
      {
        return M_PROGRAM;
      }
  }

      menuinit();
      Menu.ity=14;
      for (i=0;i<8;i++) /* 8 places in each (sub-)menu */
  {
    if (strlen((char*)pm.prog[i].name)>0) /* if not empty */
      {
        if (pm.prog[i].cat==100)    /* submenu? */
    sprintf((char*)mname,ARROW "%s",pm.prog[i].name); /* submenu name*/
        else
    sprintf((char*)mname," %s",pm.prog[i].name); /* program name */
        menuitem(mname,i+1,FALSE); /* create menu entry */
      }
  }

      menuitem((uchar*)ARROW "Options",0xfe,TRUE);
      menuitem((uchar*)ARROW "Filemenu",0xfd,FALSE);
      if (mnr!=0) menuitem((uchar*)ARROW "Up",0xfc,FALSE); /* if in submenu */

      place=menusel(TRUE);
      if (place==0xff)
  {
    /* aborted */
    LibPutMsgDlg((byte*)"Selection aborted");
    LibJumpMenu();
    return FALSE;
  }
      if (place==0xfe) return M_PREFS;
      if (place==0xfd) return M_FILE;
      if (place==0xfc) return M_PROGRAM;

      place--;
      if (pm.prog[place].cat==100) { mnr=place+1; }
      if (pm.prog[place].cat<100)
  {
    ITOS.min=pm.prog[place].cat;
    strcpy_name(ITOS.fname,pm.prog[place].name);
    return M_READY;
  }
    }
}
