#include "owbasic.h"
#include "comp.h"
#include "fnames.h"

/* Abbreviation */
#define DINT DINTEGER
#define FN_0 NULL


Keyword FAR keyfunctable[] = {
  FN_INT,    F_INT,
  FN_FLOAT,  F_FLOAT,
  FN_STRING, F_STRING,
  FN_CHAR,   F_CHAR,
  FN_CHR,    F_CHAR,
  FN_ASC,    F_ASC,
  FN_ARRAYSIZE, F_ARRAYSIZE,
  FN_CALL,   F_CALL,
  FN_PROC,   F_PROC,
  FN_FUNC,   F_FUNC,
  FN_VARDEF, D_VARDEF,
  FN_PROCFUNCDEF, D_PROCFUNCDEF,
  FN_0,      0,   /* empty last entry needed !! */
};
/* special keywords */
Keyword FAR keytable[] = {
  /* keyword (char far *), key (int) */
  FN_TRUE,   True,
  FN_FALSE,  False,
  FN_THEN,   THEN,
  FN_ELSE,   ELSE,
  FN_TO,     TO,
  FN_WHILE,  WHILE,
  FN_UNTIL,  UNTIL,
  FN_SELECT, SELECT,
  FN_STEP,   STEP,
  FN_AND,    AND,
  FN_OR,     OR,
  FN_XOR,    XOR,
  FN_NOT,    NOT,
  FN_VAR,    VAR,
  FN_FBBSIZE,PROP_FBBSIZE,
  FN_FILEBUFFER,FILEBUFFER,
  FN_CLIPBOARD,CLIPBOARD,
  FN_0,      0,   /* empty last entry needed !! */
};

/*
   all keywords, that can be treated as "command",
   but cannot be treaded as "standard procedure".
   special compiler routines are needed for different reasons.
*/
Keyword FAR commandtable[] = {
  /* keyword (char far *), key (int) */
  FN_DIM,    DIM,
  FN_ENDIF,  ENDIF,
  FN_NEXT,   NEXT,
  FN_CASE,   CASE,
  FN_ENDCASE,ENDCASE,
  FN_REM,    REM,
  FN_PRINT,  PRINT,
  FN_INPUT,  INPUT,
  FN_IF,     IF,
  FN_GOTO,   GOTO,
  FN_FOR,    FOR,
  FN_GOSUB,  GOSUB,
  FN_WEND,   WEND,
  FN_DO,     DO,
  FN_LOOP,   LOOP,
  FN_INCLUDE,INCLUDE,
  FN_APPEND, APPEND,
  FN_OVERLAY,OVERLAY,
  FN_DEFAULT,DEFAULT,
  FN_VERSION,VERSION,
  FN_WAIT,   WAIT,
  FN_ENDP,   ENDP,
  FN_PROC,   PROC,
  FN_FUNC,   FUNC,
  FN_PROCEDURE, PROC,
  FN_RETURN, RETURN,
  FN_FRETURN,FRETURN,
  FN_CONST,  CONST,
  FN_LOCAL,  LOCAL,
  FN_CALL,   CALL,
#ifndef SMALL_NO_BREAK
  FN_BREAK,  BREAK,
  FN_CONTINUE,  CONTINUE,
#endif
  FN_0,      0,   /* empty last entry needed !! */
};

#ifdef NEVER_DEFINED
Keyword FAR directivetable[] = {
  /* keyword (char far *), key (int) */
  /*FN_PVMODEL,     D_PVMODEL,*/
  FN_VARDEF,      D_VARDEF,
  FN_PROCFUNCDEF, D_PROCFUNCDEF,
  FN_0,           0, /* empty last entry needed !! */
};
#endif

/* standard procedures */
KeywordPr FAR proctable[] = {
  /* Procedure name (char far *), parameter list, binary code */
#include "fptable.c"
  FN_0,        {DUNKNOWN}, 0  /* empty last entry needed !! */
};

/* standard functions */
KeywordFn FAR functable[] = {
  /* function name (char far *), return type, parameter list, binary codes */
#include "fftable.c"
  FN_0,       0, {0}, {0},   /* empty last entry needed !! */
};
