#include <string.h>
#include <stdlib.h>
#include "owbasic.h"
#include "fnames.h"
#include "sound.h"
#include "getbatt.h"
#include "inter.h"
#include "comp.h"
#include "graphic.h"
#include "srl.h"

#ifdef __HITACHI__
#define TSTR 0xFFFFFE92
#define TCOR0 0xFFFFFE94
#define TCNT0 0xFFFFFE98
#define TCR0 0xFFFFFE9C
#define TCOR1 0xFFFFFEA0
#define TCNT1 0xFFFFFEA4
#define TCR1 0xFFFFFEA8 
#define TCOR2 0xFFFFFEAC
#define TCNT2 0xFFFFFEB0
#define TCR2  0xFFFFFEB4
#endif

char TimerRuns=0;

#ifdef __HITACHI__
void InitBreakTimer()
{
  /* timer 0 for touch screen and break test */
  *(byte*)TSTR=*(byte*)TSTR & 0xfe;
  *(int*)TCOR0=6000;
  *(int*)TCNT0=0;
  *(short*)TCR0=3;
  *(byte*)TSTR=*(byte*)TSTR | 0x01;
}
#endif

void InitTimer(void)
{
#ifdef __HITACHI__
  /* start timer 2 with RTC clock */
  *(byte*)TSTR=*(byte*)TSTR & 0xfb;
  *(int*)TCOR2=0xffffffff;
  *(int*)TCNT2=0xffffffff;
  *(short*)TCR2=3;
  *(byte*)TSTR=*(byte*)TSTR | 0x04;
#endif
#ifdef LSI_C
  setintvec();
  counter=0;
#endif
  TimerRuns=1;
}

void StartTimer()
{
  InitTimer(); /* At the moment the same as inittimer */
}

#ifdef __HITACHI__
FLOATT Timer(void)
{
  FLOATT ft;
  ft=0xffffffff - *(int*)TCNT2;
  return ft/57540;
}
#endif

#ifdef LSI_C
FLOATT Timer(void)
{
  return counter/40.0;
}
#endif

void StopTimer(void)
{
#ifdef __HITACHI__
  *(byte*)TSTR=*(byte*)TSTR & 0xfb;
#endif
#ifdef LSI_C
  resetintvec();
#endif
  TimerRuns=0;
}

FLOATT lasttime;
FLOATT nexttime;
FLOATT timestep;

int InitSync(FLOATT dt)
{
  if (dt<0.0) return 38;
  StartTimer();
  lasttime=Timer();
  nexttime=lasttime+dt;
  timestep=dt;
  return 0;
}

bool Sync()
{
  FLOATT atime=Timer();
  if (
      (atime<lasttime) ||  /* overflow */
      (atime>=nexttime)
      )
    {
      lasttime=nexttime;
      nexttime+=timestep;
      return TRUE;
    }
  return FALSE;
}
