#ifndef _OBASIC_H
#define _OBASIC_H

#define FAST
#define FAST_MACRO
#define FAST_MATH
/*#define SMALL_ARRAY*/
#define SMALL_FBDATETIME

#define SMALL_NO_BUILTIN
#define SMALL_NO_AAS
#define SMALL_NO_FORMFUNCS
#define SMALL_INTERFM

/*#define SMALL_NO_DIRECTIVES*/
/*#define SMALL_NO_BREAK*/
#define SMALL_NO_CACHE


#include "modeldef.h"
#include "ostring.h"

/*#ifdef LSI_C*/
#define REMOTE_CONTROL
/*#endif*/

#ifndef OWBVersion
 #define OWBVersion 440
#endif

/* length of different strings */
/* Identifiers */
#define IDENTLEN    17
/* memo names, Shared record names */
#define NAMELEN     30


#include "trm.h"
#include "type.h"
#include "stacks.h"

/*#define DEBUGCOMP*/
/*#define DEBUGLEX*/
/*#define DEBUGINTER*/

#include "file.h"
#include "code.h"
#include "inter.h"
#include "fnames.h"

#define PROGNAME "OWBasic"

/* special characters */
#define NEWLINESYMBOL 0xAE
#define NEWLINE '\r'

/* datatype */
/* UNKNOWN must be set to 0 */
#define DUNKNOWN         0
#define DINTEGER         1
#define DFLOAT           2
#define DSTRING          3
#define DBOOLEAN         4
#define DCHAR            5
#define DCONSTANT        6
#define DLABEL           7
#define DREFERENCE       8
#define DFPTR            9

#define TYPEMASK         15

/* special kind of data (bit mask) */
#define KREFERENCE       16
#define KLAST            32
#define KARRAY           64
#define KCONST           128

/* token_type */
#define TCHAR            1
#define TKEY             2
#define TSTRING          3
#define TEDELIM          4
#define TOPERATOR        5
#define TNUMBER          6
#define TIDENT           7
#define TDELIM           8
#define TLABEL           9

/*
 * values for tok ( lex() )
 * for single characters their ASCII value is used
 */

#define LESS            256
#define GREATER         258
#define NOT_LESS        259
#define NOT_EQUAL       260
#define NOT_GREATER     261
#define DELIMITER       262
#define NUMBER          263
#define IDENT           264
#define LABEL           265
#define STRING          266
#define INT             267
#define FLOAT           268
#define CONST           269
/* -------------------------- */
#define PRINT           301
#define INPUT           302
#define IF              303
#define THEN            304
#define ELSE            314
#define ENDIF           322
#define CASE            352
#define SELECT          353
#define ENDCASE         354
#define UNTIL           356
#define WHILE           357
#define WEND            358
#define DO              359
#define LOOP            360
#define FOR             305
#define NEXT            306
#define TO              307
#define GOTO            308
#define GOSUB           311
#define RETURN          312
#define END             313
#define REM             318
#define DIM             325
#define DEFAULT         326
#define WAIT            328
#define INCLUDE         337
#define APPEND          338
#define OVERLAY         339
#define STEP            340
#define VERSION         341
#define PROC            342
#define ENDP            343
#define MULDIV          344
#define AND             345
#define OR              346
#define VAR             347
#define FILEBUFFER      348
#define XOR             349
#define True            350
#define False           351
#define FUNC            361
#define CLIPBOARD       362
#define LOCAL           363
#define CALL            364
#define BREAK           365
#define CONTINUE        366
#define FRETURN         367
#define NOT             368
#define PROP_FBBSIZE    369

/*#define D_PVMODEL       400*/
#define D_VARDEF        401
#define D_PROCFUNCDEF   402

#define F_INT           1
#define F_FLOAT         2
#define F_STRING        3
#define F_CHAR          4
#define F_ASC           10
#define F_ARRAYSIZE     11
#define F_CALL          20
#define F_PROC          21
#define F_FUNC          22


#define UNKNOWN         999

/*#ifdef SMALL_NO_AAS
 #define B_ARRAY_ADDR_S   B_ARRAY_ADDR
 #define B_ARRAY2_ADDR_S  B_ARRAY2_ADDR
#endif*/

/*
 * constants for ReturnCode of compile_command
 */

#define RC_CONTINUE 1
#define RC_INCLUDE 2
#define RC_APPEND 3
#define RC_EXIT 4

/*
 * constants for status of mode
 */
#define STATUS_NORMAL   0
#define STATUS_RC       1
#define STATUS_FIND_RTE 2
#define STATUS_BUILTIN  3
#define STATUS_CACHE    4

extern word mymode;
extern word mystatus;

void Restart(byte status);

/*
 * internal status, return code
 */
#define O_NORMAL 0
#define O_COMPILE_ERROR 1
#define O_RUNTIME_ERROR 2

/*extern byte oret;*/

extern byte intchar;
extern byte floatchar;

/* top of stack for control structures (compiler) */
extern int ctos;

/*
 * Limits
 */
#ifdef LSI_C
#define FOR_NEST        15
#define NUM_PROC        250

#ifndef DEBUGCOMP
#define PROG_SIZE       0x1510 /* 0x14A0 */ /* 0x1410 */
#else
#define PROG_SIZE       0x800
#endif

#define G_STACK_SIZE    20
#define DATASIZE        0x3000
#define MAXSTRLEN       150
#define S_STACK_SIZE    5
#endif

#ifdef __HITACHI__
#define FOR_NEST        160
#define NUM_PROC        1000
#define PROG_SIZE       90000
#define G_STACK_SIZE    50
#define DATASIZE        0x30000
#define MAXSTRLEN       1500
#define S_STACK_SIZE    10
#endif

extern PC g_stack[G_STACK_SIZE];
extern PC* g_stack_ptr;

PC gpop(void);
void gpush(PC pc);

extern uchar *prog;	/* current pos. to be compiled */
extern uchar *aprog;	/* pointer for debug output lex() */
extern uchar *prog_start; /* the source */

typedef void (FAR * interfunc)(void);
#ifdef DEBUGINTER
#define execute executec
#else
#define execute executea
#endif

extern byte declaration_required;
extern bool overlays_used;
extern bool show_compiling;
extern bool save_to_cache;
extern int datanext; /* first free "address" after variables (runtime) */
extern int firstconst; /* start of constants (compile and runtime)*/

extern interfunc FAR ftable[];
extern codet bin[]; /* binary code */
extern PC bin_start;
extern PC pc;
extern PC lastpc;

/*void _asm_i();*/
#define GETIPC(ii) ii=*pc.i;pc.i++
/*#define GETINTPC(pp) _asm_i("\nMOV BX,[pc_].W\nMOV AX,[BX].W\nADD BX,2\nMOV [pc_].W,BX\nMOV BX," #pp "_\nMOV [BX],AX")*/

void _asm_pp();
#ifdef LSI_C
#define GETPCPC(pp) _asm_pp("\nMOV BX,[pc_].W\nMOV AX,[BX].W\nADD BX,2\nMOV [pc_].W,BX\nMOV BX," #pp "_\nMOV [BX],AX")
#else
#define GETPCPC(pp)  pp=*pc.pc; pc.p++;
#endif

#define GETCODEPC(code) code=*(pc.c); pc.c++;

#define GETFLOATPC(fl)  fl=*pc.f; pc.f++;

extern int FAR xdata[DATASIZE];
#ifndef SMALL_NO_BUILTIN
extern codet FAR ibin[]; /* initialization data for binary code */
extern unsigned int initcodesize;
#ifndef SMALL_ARRAY
extern const int FAR xdata_var[];
#define XDATA_VAR(n)  (xdata_var[n])
#else
extern const unsigned char FAR xdata_var[];
#define XDATA_VAR(n)  ((xdata_var[n] == 255) ? 1302 : xdata_var[n])
#endif
extern const int FAR xdata_const[];
#endif

#define BOOL_XOR(l,r) ((l) ^ (r))

#ifdef __HITACHI__
 #define PV_MODEL 1600
#endif
#ifdef LSI_C
 #define PV_MODEL 450
#endif

extern int StringStackPointer;
extern uchar *SStack[S_STACK_SIZE];

#define STOS stos
#define SST1 sst1
#define SST2 sst2
extern uchar *stos;
extern uchar *sst1;
extern uchar *sst2;

void spop(int vadr);
void spop1(void);
void spop2(void);
void spopn(int n);
void spush(int vadr);
void spush1(void);

extern char FAR sin_tab[];

extern jmp_buf errorret;

void NewInp(byte *c,int maxchr);

/* Touch variables */
extern int tchxi, tchyi, tchobji, tchstsi; /* indices of touch variables */
extern int FAR *tchxp;
extern int FAR *tchyp;
extern int FAR *tchstsp;
extern int FAR *tchobjp; /* addresses of touch variables */

extern int pvmodeli, owbversioni; /* indices of version informations */
extern int FAR *pvmodelp;
extern int FAR *owbversionp;

extern int block_errors;
extern int error;
extern int inputrc;

int execute(void);

void loadsettings(void);
void savesettings(void);
void editsettings(void);

/* run time error */
void rterror(const uchar FAR *func,int enr);

typedef struct pref_ {
  /* persistent user settings */
  int ver;
  int progsub;
  int includesub;
  int statistics;
  int startmenu;
  int finalwait;
  int askabort;
  int clearoverlay;
  int autorun;
  int restart;
  int rterror;
  int cacheing; /* experimental cacheing (MB,4.22) */
  int showcompiling; /* disabling of compiler screen possible (MB,4.20) */
  char owbparam[MAXSTRLEN]; /* OWBasic program parameters (MB,4.22) */
} Pref;

typedef struct switch_
{
  /* temporary settings */
  /*  byte printwhilecomp;*/
  byte remote;
  byte calllevel;
  byte statistics;
  byte cached; /* current program cached */
  byte cacheing; /* cacheing allowed */
  int last;
} Switches;

#define SETTINGSVER (0x0200+sizeof(Pref))

extern Pref pref;
extern Switches switches;

extern bool isFindRTE;

extern int desired_version;
extern int current_version;
extern int owbparameter;

extern int pvmodel;


/* organization of programs */

#define PROGRAMSIG (uchar *)"! "
#define INCLUDESIG (uchar *)"!*"
#define APPENDSIG (uchar *)"!+"

#define MMAIN 1
#define MINCLUDE 2
#define MAPPEND 3

bool loadprogmemo();
bool loadprog();

void default_prefs(void);

#define M_FILE 1
#define M_PREFS 2
#define M_PROGRAM 3
#define M_READY 99

int filemenu();
int prefsmenu(void);
int programmenu();

/* touch */
extern bool touched, newtouched;
void WaitNoTouch(void);

/* dyn string storage */
extern int firststring;
void resetstrings(void);
void printstrings(void);
int insertstring(int ref,const uchar *st);
void deletestring(int addr);
void garbagecollection(void);
void getvar(int vadr,uchar *where);
void putvar(int vadr,const uchar *value);

/* fast timer ...*/
#ifdef LSI_C
extern unsigned int counter;
extern void setintvec(void);
extern void setintvecdiv0(void);
extern void resetintvec(void);
extern int timerruns;
#endif

extern char TimerRuns;

void InitTimer(void);
FLOATT Timer(void);
void StopTimer(void);
void StartTimer(void);

int InitSync(FLOATT dt);
bool Sync();
#endif
